// ColourString.h: interface for the CColourString class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLOURSTRING_H__E8EB8C20_7FAE_11D4_ABB4_00508B4D9A5B__INCLUDED_)
#define AFX_COLOURSTRING_H__E8EB8C20_7FAE_11D4_ABB4_00508B4D9A5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// ***************************************************************************
//DESCRIPTION:
//		Class definition of object to convert code to Html
//CREATED:
//		1-9-2000, 12:54:06 by john@mctainsh.com
// ***************************************************************************
class CColourString  
{
//Operators
public:
	CColourString( CString sSourceCode, BOOL bPreFormat = true, int nTabInterval = 4 );
	virtual ~CColourString();

	void ConverToHtml();
	CString GetHtml();


//Operators
private:
	void WriteWord();
	void NewLine();
	void ProcessQuote( TCHAR ch, TCHAR chLast, TCHAR chQuoteTerminator );

//Attributes:
private:
	CString			m_sOut;							//Output data string converted to Html
	const CString	m_sSource;						//Source code to be converted
	CString			m_sWord;						//Word being currently built
	int				m_nColumn;						//Column to be written to (Used for Tab calculations)
	BOOL			m_bPreFormatting;				//True when converting for <pre> formatting. Dont expand spaced or carage returns.
	int				m_nTabInterval;					//Number of spacing per TAB

	//Conversion state
	enum enumConversionState
	{
		eNormal,									//Reading plain text
		eSingleQuote,								//Within Single Quotation marks '
		eDoubleQuote,								//Within Double Quotation marks "
		eLineComment,								//Within line comment //
		eContinousComment							//Within a comtinous comment /* */
	}				m_convState;

};

#endif // !defined(AFX_COLOURSTRING_H__E8EB8C20_7FAE_11D4_ABB4_00508B4D9A5B__INCLUDED_)
