


<!-- #include virtual="/Inc/NoteHeader.inc" --> 

<h4>Description.</h4>
      
<p>The Microsoft ActiveX Data Objects (ADO) object model defines a collection of programmable 
objects that can be used in any language that supports both COM and Automation to access Databases. In 
this example we will be using ADO to access a Microsoft Access Database.
      
<p>Note: I have been working on ADO for 5 days now and this is what I have learnt in this
time. Also remember you need Microsoft IIS running on the server since this is all
server side processing.

   
<h4>How to use it.</h4>
      
Start as always by inserting <code>&lt;%@ LANGUAGE = VBScript %&gt;</code> at the top of the page.
The file I will be working with is called <code>TestADO.mdb</code>. When setting these demos
up for yourself de sure to change the <code>DBQ=D:\Inetpub\DevelopmentPrivate\TestADO.mdb;</code> path
to your local path.

<h4>Read data from the database. (View recordes)</h4>
      
The important code in this block is where the record is read from the database. 
Click <a href=AdoReadDemo.asp title="ADO Read Demo"> here</a> to view the results.
      
<pre>
<font color="#006600">'Create and open connection to the data source</font>
strProvider <font color="#FF0000">=</font> <font color="#FF00FF">"Driver={Microsoft Access Driver (*.mdb)};"</font> <font color="#FF0000">&</font>_
              <font color="#FF00FF">"DBQ=D:\Inetpub\Development\ASP\TestADO.mdb;"</font>

<font color="#006600">'Setup the match query</font>
strQuery <font color="#FF0000">=</font> <font color="#FF00FF">"SELECT * FROM Comment;"</font>
    
<font color="#006600">'Instantiate a Recordset object and open a recordset using the Open method </font>
<font color="#0088FF">Set</font> rst <font color="#FF0000">=</font> Server.CreateObject<font color="#FF0000">(</font><font color="#FF00FF">"ADODB.recordset"</font><font color="#FF0000">)</font>
rst.Open strQuery<font color="#FF0000">,</font> strProvider

<font color="#0088FF">ON</font> ERROR <font color="#0088FF">RESUME</font> <font color="#0088FF">NEXT</font>
<font color="#0088FF">While</font> <font color="#FF0000">(</font> <font color="#0088FF">not</font> rst.EOF <font color="#FF0000">)</font>
    strAuthor          <font color="#FF0000">=</font> rst<font color="#FF0000">(</font> <font color="#FF00FF">"Author"</font> <font color="#FF0000">)</font>
    nAge               <font color="#FF0000">=</font> rst<font color="#FF0000">(</font> <font color="#FF00FF">"Age"</font> <font color="#FF0000">)</font>
    strMessage         <font color="#FF0000">=</font> rst<font color="#FF0000">(</font> <font color="#FF00FF">"Message"</font> <font color="#FF0000">)</font>
    dateLastRefreshed  <font color="#FF0000">=</font> rst<font color="#FF0000">(</font> <font color="#FF00FF">"LastRefreshed"</font> <font color="#FF0000">)</font>
    
    nDay    <font color="#FF0000">=</font> Day<font color="#FF0000">(</font> dateLastRefreshed <font color="#FF0000">)</font>
    nMonth  <font color="#FF0000">=</font> Month<font color="#FF0000">(</font> dateLastRefreshed <font color="#FF0000">)</font>
    nYear   <font color="#FF0000">=</font> Year<font color="#FF0000">(</font> dateLastRefreshed <font color="#FF0000">)</font>
    
    <font color="#FF0000">%</font><font color="#FF0000">></font>
    <font color="#FF0000"><</font>tr<font color="#FF0000">></font>
        <font color="#FF0000"><</font>td<font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">%</font><font color="#FF0000">=</font>strAuthor<font color="#FF0000">%</font><font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">/</font>td<font color="#FF0000">></font>
        <font color="#FF0000"><</font>td<font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">%</font><font color="#FF0000">=</font>nAge<font color="#FF0000">%</font><font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">/</font>td<font color="#FF0000">></font>
        <font color="#FF0000"><</font>td<font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">%</font><font color="#FF0000">=</font>strMessage<font color="#FF0000">%</font><font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">/</font>td<font color="#FF0000">></font>
        <font color="#FF0000"><</font>td<font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">%</font><font color="#FF0000">=</font>nDay<font color="#FF0000">%</font><font color="#FF0000">></font><font color="#FF0000">-</font><font color="#FF0000"><</font><font color="#FF0000">%</font><font color="#FF0000">=</font>nMonth<font color="#FF0000">%</font><font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">%</font><font color="#FF0000">=</font>nYear<font color="#FF0000">%</font><font color="#FF0000">></font><font color="#FF0000"><</font><font color="#FF0000">/</font>td<font color="#FF0000">></font>
    <font color="#FF0000"><</font><font color="#FF0000">/</font>tr<font color="#FF0000">></font>    
    <font color="#FF0000"><</font><font color="#FF0000">%</font>
    
    rst.MoveNext
<font color="#0088FF">Wend</font>

</pre>

<h4>Append data to the database. (Adding records)</h4>
      
The important code in this block is where the record is Added to the database. 
Click <a href=AdoAppendDemo.asp title="ADO Append Demo"> here</a> to view the results. Note
an important feature of ASP that is demonstrated in this sample is its ability
to post messages to itself. In this way the form and processing logic can be
kept in the same page.

<pre>
<font color="#006600">'***************************************************************************</font>
<font color="#006600">'This is processing of the Form Request</font>
strAuthor   <font color="#FF0000">=</font> request.form<font color="#FF0000">(</font><font color="#FF00FF">"Author"</font><font color="#FF0000">)</font>
nAge        <font color="#FF0000">=</font> Cint<font color="#FF0000">(</font> request.form<font color="#FF0000">(</font><font color="#FF00FF">"Age"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
strMessage  <font color="#FF0000">=</font> request.form<font color="#FF0000">(</font><font color="#FF00FF">"Message"</font><font color="#FF0000">)</font>

<font color="#0088FF">IF</font> strMessage <font color="#FF0000">=</font> <font color="#FF00FF">""</font> THEN
    iLenNote<font color="#FF0000">=</font><font color="#6600FF">255</font>
<font color="#0088FF">ELSE</font>
    iLenNote <font color="#FF0000">=</font> Len<font color="#FF0000">(</font>strMessage<font color="#FF0000">)</font>
<font color="#0088FF">END</font> <font color="#0088FF">IF</font>

<font color="#006600">'Connects to the Access driver and Access database in the Inetpub</font>
<font color="#006600">'directory where the database is saved</font>
strProvider <font color="#FF0000">=</font> <font color="#FF00FF">"Driver={Microsoft Access Driver (*.mdb)};"</font> <font color="#FF0000">&</font>_
              <font color="#FF00FF">"DBQ=D:\Inetpub\Development\ASP\TestADO.mdb;"</font>
<font color="#006600">'Creates an instance of an Active Server component</font>
<font color="#0088FF">set</font> objConn <font color="#FF0000">=</font> server.createobject<font color="#FF0000">(</font><font color="#FF00FF">"ADODB.Connection"</font><font color="#FF0000">)</font>

<font color="#006600">'Opens the connection to the data store</font>
objConn.Open strProvider

<font color="#006600">'Instantiate Command object and use ActiveConnection property to</font>
<font color="#006600">'attach connection to Command object</font>
<font color="#0088FF">set</font> cm <font color="#FF0000">=</font> Server.CreateObject<font color="#FF0000">(</font><font color="#FF00FF">"ADODB.Command"</font><font color="#FF0000">)</font>
cm.ActiveConnection <font color="#FF0000">=</font> objConn

<font color="#006600">'Define SQL query</font>
cm.CommandText <font color="#FF0000">=</font> <font color="#FF00FF">"INSERT INTO Comment (Author,Age,Message,LastRefreshed)"</font> <font color="#FF0000">&</font>_
                 <font color="#FF00FF">" VALUES (?,?,?,?)"</font> 
<font color="#006600">'Define query parameter configuration information for guestbook fields</font>
<font color="#0088FF">set</font> objparam<font color="#FF0000">=</font>cm.createparameter<font color="#FF0000">(</font><font color="#FF0000">,</font> <font color="#6600FF">200</font><font color="#FF0000">,</font> <font color="#FF0000">,</font>  <font color="#6600FF">50</font><font color="#FF0000">,</font> strAuthor<font color="#FF0000">)</font>
cm.parameters.append objparam
<font color="#0088FF">set</font> objparam<font color="#FF0000">=</font>cm.createparameter<font color="#FF0000">(</font><font color="#FF0000">,</font>   <font color="#6600FF">3</font><font color="#FF0000">,</font> <font color="#FF0000">,</font>   <font color="#6600FF">4</font><font color="#FF0000">,</font> nAge <font color="#FF0000">)</font>
cm.parameters.append objparam
<font color="#0088FF">set</font> objparam<font color="#FF0000">=</font>cm.createparameter<font color="#FF0000">(</font><font color="#FF0000">,</font> <font color="#6600FF">201</font><font color="#FF0000">,</font> <font color="#FF0000">,</font> iLenNote<font color="#FF0000">,</font> strMessage<font color="#FF0000">)</font>
cm.parameters.append objparam
<font color="#0088FF">set</font> objparam<font color="#FF0000">=</font>cm.createparameter<font color="#FF0000">(</font><font color="#FF0000">,</font> <font color="#6600FF">135</font><font color="#FF0000">,</font> <font color="#FF0000">,</font>  <font color="#6600FF">50</font><font color="#FF0000">,</font> Now <font color="#FF0000">)</font>
cm.parameters.append objparam    
cm.execute
<font color="#006600">'Say that all went well</font>
Response.Write<font color="#FF0000">(</font> <font color="#FF00FF">"Thank you for your input!"</font> <font color="#FF0000">)</font>
</pre>


<h4>Modifying data in the database. (Editing records)</h4>
      
The important code in this block is where the data is changed in the database. 
Click <a href=AdoEditDemo.asp title="ADO Edit Demo"> here</a> to view the results. Note
an important feature of ASP that is demonstrated in this sample is its ability
to post messages to itself. In this way the form and processing logic can be
kept in the same page.

<pre>
<font color="#006600">'Connects to the Access driver and Access database in the Inetpub</font>
<font color="#006600">'directory where the database is saved</font>
strProvider <font color="#FF0000">=</font> <font color="#FF00FF">"Driver={Microsoft Access Driver (*.mdb)};"</font> <font color="#FF0000">&</font>_
              <font color="#FF00FF">"DBQ=D:\Inetpub\Development\ASP\TestADO.mdb;"</font>
    
<font color="#006600">'Instantiate a Recordset object and open a recordset using</font>
<font color="#006600">'the Open method </font>
<font color="#0088FF">Set</font> rst <font color="#FF0000">=</font> Server.CreateObject<font color="#FF0000">(</font><font color="#FF00FF">"ADODB.recordset"</font><font color="#FF0000">)</font>

<font color="#006600">'Save the new values to the table</font>
sql <font color="#FF0000">=</font>    <font color="#FF00FF">"UPDATE Comment"</font> <font color="#FF0000">&</font>_
        <font color="#FF00FF">" SET Comment.Author = '"</font> <font color="#FF0000">&</font> strNewAuthor <font color="#FF0000">&</font> <font color="#FF00FF">"'"</font> <font color="#FF0000">&</font>_
        <font color="#FF00FF">" WHERE Comment.ID = "</font> <font color="#FF0000">&</font> nRowID <font color="#FF0000">&</font> <font color="#FF00FF">";"</font>
rst.open sql<font color="#FF0000">,</font>strProvider
</pre>


<h4>Deleting data in the database. (Removing records)</h4>
      
The important code in this block is where the data is deleted from the database. 
Click <a href=AdoDeleteDemo.asp title="ADO Delete Demo"> here</a> to view the results. Note
an important feature of ASP that is demonstrated in this sample is its ability
to post messages to itself. In this way the form and processing logic can be
kept in the same page. Note, there is no check to see if the record existed
before the delete and no error handling here.

<pre>
<font color="#006600">'This is processing of the Form Request</font>
strRowID <font color="#FF0000">=</font> request.form<font color="#FF0000">(</font><font color="#FF00FF">"RowID"</font><font color="#FF0000">)</font>

strProvider <font color="#FF0000">=</font> <font color="#FF00FF">"Driver={Microsoft Access Driver (*.mdb)};"</font> <font color="#FF0000">&</font>_
              <font color="#FF00FF">"DBQ=D:\Inetpub\Development\ASP\TestADO.mdb;"</font>
    
<font color="#006600">'Creates an instance of an Active server component</font>
<font color="#0088FF">set</font> objConn <font color="#FF0000">=</font> server.createobject<font color="#FF0000">(</font><font color="#FF00FF">"ADODB.Connection"</font><font color="#FF0000">)</font>
objConn.Open strProvider
        
<font color="#006600">'Instantiate Command object and use ActiveConnection property to</font>
<font color="#006600">'attach connection to Command object</font>
<font color="#0088FF">set</font> cm <font color="#FF0000">=</font> Server.CreateObject<font color="#FF0000">(</font><font color="#FF00FF">"ADODB.Command"</font><font color="#FF0000">)</font>
cm.ActiveConnection <font color="#FF0000">=</font> objConn
        
<font color="#006600">'Define SQL query</font>
cm.CommandText <font color="#FF0000">=</font> <font color="#FF00FF">"DELETE FROM Comment WHERE ID = "</font> <font color="#FF0000">&</font>strRowID
cm.Execute

Response.Write<font color="#FF0000">(</font> <font color="#FF00FF">"If the Record existed then it was deleted."</font> <font color="#FF0000">)</font>

</pre>

<h4>What needs further investigation.</h4>

We are not doing any error handling. If any one knows how to do this add it to the comments.
      
<!-- #include virtual="/Inc/NoteFooter.inc" --> 




