<!-- #include virtual="/Inc/NoteHeader.inc" --> 

<h1>Description</h1>
      
<p>The <code>DateTime</code> class allows the formatting and managing of
date and time. Of particular interest to international applications
is the ability to format strings according to locality.</p>  

<h2>includes</h2>

<p>To use dates and times it is necessary to use include the following.</p>        

<pre>
    <font color="#0088FF">using</font> System<font color="#FF0000">;</font>                                   <font color="#006600">//Date time</font>
    <font color="#0088FF">using</font> System.Globalization<font color="#FF0000">;</font>                     <font color="#006600">//Date Formatting</font>
</pre>

<h2>Modifying Dates</h2>

<p>Simple addition and subtraction can be applied to <code>DateTime</code> as 
follows. The following determines the date that is 31 days after 
25-Jan-2001.</p>        

<pre>
    DateTime dtAccountOpened <font color="#FF0000">=</font> <font color="#0088FF">new</font> DateTime<font color="#FF0000">(</font> <font color="#6600FF">2001</font><font color="#FF0000">,</font> <font color="#6600FF">1</font><font color="#FF0000">,</font> <font color="#6600FF">25</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    DateTime dtPaymentDue <font color="#FF0000">=</font> dtAccountOpened.AddDays<font color="#FF0000">(</font> <font color="#6600FF">31.0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>
      
<h2>Formatting to a specific layout</h2>

<p>Use the following to format my birthday to 2-Jun-1965.</p>        

<pre>
    DateTime dtNow <font color="#FF0000">=</font> DateTime.Today<font color="#FF0000">;</font>                <font color="#006600">//Now is not necessary</font>
    string sText <font color="#FF0000">=</font> dtNow.Format<font color="#FF0000">(</font> <font color="#FF00FF">"d-MMM-yyyy"</font><font color="#FF0000">,</font> DateTimeFormatInfo.InvariantInfo <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<h2>Formatting to a specific locality</h2>

<p>The following code will output "22/06/1965 09:00:00" in New Zealand and 
"06/22/1965 09:00:00" in USA. Note the month and day is placed in the local format.</p>        

<pre>
    DateTime dtNow <font color="#FF0000">=</font> DateTime.Now<font color="#FF0000">;</font>
    string sNow <font color="#FF0000">=</font> dtNow.Format<font color="#FF0000">(</font> <font color="#FF00FF">"G"</font><font color="#FF0000">,</font> DateTimeFormatInfo.CurrentInfo <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




