


<!-- #include virtual="/Inc/NoteHeader.inc" --> 

<h4>Description.</h4>
      
<p>Scanning through a directory tree is often used when searching for file. Working up and
down the tree is sometimes tricky when it is necessary to remember where you were. The following
routine scans for files and directorys in the given path. If it finds a directory it
calls itself with the new directory name and searches into that. This kind of re-enterant 
code looks quite elligant but is very dangerous. If the tree is large the application
can quickly run out of stack memory which is dificult to detect and event harder to recover
from. Use this information with caution.</p>

<pre>
<font color="#006600">/////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//FUNCTION</font>
<font color="#006600">//  Recursively search a given directory.</font>
<font color="#006600">//  WARNING THIS FUNCTION IS RENTERANT BY ITSELF.</font>
<font color="#006600">//CREATED</font>
<font color="#006600">//  8-5-1999  17:12:57</font>
<font color="#006600">//PARAMS</font>
<font color="#006600">//  sDirectoryName  Directory name to search such as "C:\Temp\"</font>
<font color="#0088FF">void</font> SearchDirectory<font color="#FF0000">(</font> CString sDirectoryName <font color="#FF0000">)</font> 
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"SearchDirectory(%s)\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> sDirectoryName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    CFileFind finder<font color="#FF0000">;</font>
    BOOL bWorking <font color="#FF0000">=</font> finder.FindFile<font color="#FF0000">(</font> sDirectoryName<font color="#FF0000">+</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"*.*"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#006600">//Loop untill no more files exist in the directory</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> bWorking <font color="#FF0000">)</font>   
    <font color="#FF0000">{</font>
        bWorking <font color="#FF0000">=</font> finder.FindNextFile<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#006600">//Skip the Dots</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> finder.IsDots<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
            <font color="#0088FF">continue</font><font color="#FF0000">;</font>
        <font color="#006600">//If we find a directory we drill down into it (RE-ENTER HERE!)</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> finder.IsDirectory<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            SearchDirectory<font color="#FF0000">(</font> finder.GetFilePath<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">+</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"\\") );</font>
            <font color="#0088FF">continue</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>

        <font color="#006600">//We have a file so process it</font>
        <font color="#0088FF">static</font> <font color="#0088FF">int</font> n <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">" %d File %s \n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> n<font color="#FF0000">+</font><font color="#FF0000">+</font><font color="#FF0000">,</font> finder.GetFilePath<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">" %d File %s \n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> n<font color="#FF0000">,</font> finder.GetFilePath<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>


<!-- #include virtual="/Inc/NoteFooter.inc" --> 




