


<!-- #include virtual="/Inc/NoteHeader.inc" --> 

<img src='/images/DownLoad.gif'>&nbsp;<a href="SyntaxColourHtml.zip">Download demo class - 5 Kb </a><br>
	
<h4>Description.</h4>
      
<p>This class allows C++ source code to be converted to HTML for display in a web 
page and syntax coloured. It is not a particularly fast routine so if the code is a little
slow don't run it when you serve the page do it when you are making the html files.</p>

<h4>How to use it on a CPP file.</h4>

<p>In this example the <code>CColourString</code> class is used to convert the string.</p>

<pre>
    <font color="#006600">//Colour the string now</font>
    CColourString colourConverter<font color="#FF0000">(</font> sSourceCode <font color="#FF0000">)</font><font color="#FF0000">;</font>
    colourConverter.ConverToHtml<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    CString sResult <font color="#FF0000">=</font> colourConverter.GetHtml<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<h4>How to use it on a HTML file.</h4>

<p>In this example the source code is held in a HTML string and is surounded
by &lt;pre&gt; tags. These tags are located and the text between then
is colour coded and inserted back between the tags. Special HTML codes are first converted 
from HTML to C++ this is only necessary if HTML editor has converted the gymphs to HTML
tags without your consent. I use this function on all my web pages
that I want syntax coloured. I create an HTML page and suround my
C++ code with &lt;pre&gt; tags, the function below does the rest.</p>


<pre>
<font color="#006600">/////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//FUNCTION</font>
<font color="#006600">//  Syntax colour sections within <pre> tags to C++ colouring.</font>
<font color="#006600">//CREATED</font>
<font color="#006600">//  25-9-2000  8:48:00</font>
<font color="#006600">//PARAMS</font>
<font color="#006600">//  sHtml   Html page to process as a string</font>
<font color="#006600">//RETURNS</font>
<font color="#006600">//  New page (as a string) with syntax coloured <pre> sections.</font>
CString SyntaxColourHtml<font color="#FF0000">(</font> CString sHtml <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    CString sOut<font color="#FF0000">;</font>                 <font color="#006600">//Output data string</font>
    CString sInLower <font color="#FF0000">=</font> sHtml<font color="#FF0000">;</font>     <font color="#006600">//Lower case input string</font>
    sInLower.MakeLower<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#0088FF">int</font> nCurrentStart <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>        <font color="#006600">//Where to start searching the section from</font>
    <font color="#0088FF">int</font> nStart<font color="#FF0000">,</font> nEnd<font color="#FF0000">;</font>             <font color="#006600">//Marking start and end of the code section</font>
    <font color="#0088FF">do</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Find opening code</font>
        <font color="#0088FF">const</font> <font color="#0088FF">int</font> nTagLen <font color="#FF0000">=</font> <font color="#6600FF">5</font><font color="#FF0000">;</font>
        nStart <font color="#FF0000">=</font> sInLower.Find<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"<pre>"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nCurrentStart <font color="#FF0000">)</font><font color="#FF0000">;</font>
        nEnd   <font color="#FF0000">=</font> sInLower.Find<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"</pre>"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nCurrentStart <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> nStart <font color="#FF0000">></font> <font color="#FF0000">-</font><font color="#6600FF">1</font> <font color="#FF0000">&</font><font color="#FF0000">&</font> nEnd <font color="#FF0000">></font> <font color="#FF0000">-</font><font color="#6600FF">1</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            CString sBefore <font color="#FF0000">=</font> sHtml.Mid<font color="#FF0000">(</font> nCurrentStart<font color="#FF0000">,</font> nStart<font color="#FF0000">-</font>nCurrentStart <font color="#FF0000">)</font><font color="#FF0000">;</font>
            sOut <font color="#FF0000">+</font><font color="#FF0000">=</font> sBefore<font color="#FF0000">;</font>
            nCurrentStart <font color="#FF0000">=</font> nEnd <font color="#FF0000">+</font> nTagLen <font color="#FF0000">+</font> <font color="#6600FF">1</font><font color="#FF0000">;</font>

            CString sSourceCode <font color="#FF0000">=</font> sHtml.Mid<font color="#FF0000">(</font> nStart<font color="#FF0000">+</font>nTagLen<font color="#FF0000">,</font> 
                                             nEnd<font color="#FF0000">-</font><font color="#FF0000">(</font>nStart<font color="#FF0000">+</font>nTagLen<font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#006600">//HTML reserved word to Glyph replacement.</font>
            sSourceCode.Replace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"&quot;"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"\""</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            sSourceCode.Replace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"&gt;"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">">"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            sSourceCode.Replace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"&lt;"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"<"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            sSourceCode.Replace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"&nbsp;"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">" "</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            sSourceCode.Replace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"&amp;"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"&"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

            CColourString colourConverter<font color="#FF0000">(</font> sSourceCode <font color="#FF0000">)</font><font color="#FF0000">;</font>
            colourConverter.ConverToHtml<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            sOut <font color="#FF0000">+</font><font color="#FF0000">=</font> colourConverter.GetHtml<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>

        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font> <font color="#0088FF">while</font><font color="#FF0000">(</font> nStart <font color="#FF0000">></font> <font color="#FF0000">-</font><font color="#6600FF">1</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Append what ever remains</font>
    sOut <font color="#FF0000">+</font><font color="#FF0000">=</font> sHtml.Mid<font color="#FF0000">(</font> nCurrentStart<font color="#FF0000">,</font> sHtml.GetLength<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">-</font>nCurrentStart <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#0088FF">return</font> sOut<font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>


<!-- #include virtual="/Inc/NoteFooter.inc" --> 




