
<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h4>Description.</h4>
      
<p>Arrays and collections are simple ways to store sets of data.
Arrays are more suited to simple known size groups. Collections are
better for things that are more dynamic in size and need to be
searched or ordered.</p>
   
<h4>Simple one dimensional array.</h4>

Declare an array using the <code>[]</code> operator. Then use
<code>new</code> to allocate the memory and size for the
array. You can use arrays with objects and primitive data types
in the same manner. One handy thing to note is the <code>.length</code>
attribute contains the length of the array (one more than the last
index value).

<pre>
<font color="#0088FF">import</font> java.lang.Math<font color="#FF0000">;</font>
...
    <font color="#006600">//Declare and populate the array</font>
    <font color="#0088FF">double</font> aryScore<font color="#FF0000">[</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> <font color="#0088FF">new</font> <font color="#0088FF">double</font> <font color="#FF0000">[</font><font color="#6600FF">16</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> n <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> n <font color="#FF0000"><</font> aryScore.length<font color="#FF0000">;</font> n<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
        aryScore<font color="#FF0000">[</font>n<font color="#FF0000">]</font> <font color="#FF0000">=</font> Math.sqrt<font color="#FF0000">(</font> n <font color="#FF0000">)</font><font color="#FF0000">;</font>
        
    <font color="#006600">//Display the array</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> n <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> n <font color="#FF0000"><</font> aryScore.length<font color="#FF0000">;</font> n<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
        System.out.println<font color="#FF0000">(</font> aryScore<font color="#FF0000">[</font>n<font color="#FF0000">]</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<h4>Multi dimensional array.</h4>

<p>This first example shows a simple rectangular array.</p>

<pre>
    <font color="#006600">//Rectangular 3 x 2 array</font>
    <font color="#0088FF">int</font> aryPlain <font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> <font color="#FF0000">{</font> <font color="#FF0000">{</font> <font color="#6600FF">1</font><font color="#FF0000">,</font>  <font color="#6600FF">2</font><font color="#FF0000">,</font>  <font color="#6600FF">3</font> <font color="#FF0000">}</font><font color="#FF0000">,</font>
                          <font color="#FF0000">{</font> <font color="#6600FF">4</font><font color="#FF0000">,</font>  <font color="#6600FF">5</font><font color="#FF0000">,</font>  <font color="#6600FF">6</font> <font color="#FF0000">}</font> <font color="#FF0000">}</font><font color="#FF0000">;</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nRow <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nRow <font color="#FF0000"><</font> aryPlain.length<font color="#FF0000">;</font> nRow<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        System.out.println<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nCol <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nCol <font color="#FF0000"><</font> aryPlain<font color="#FF0000">[</font>nRow<font color="#FF0000">]</font>.length<font color="#FF0000">;</font> nCol<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
            System.out.print<font color="#FF0000">(</font> aryPlain<font color="#FF0000">[</font>nRow<font color="#FF0000">]</font><font color="#FF0000">[</font>nCol<font color="#FF0000">]</font> <font color="#FF0000">+</font> <font color="#FF00FF">" "</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
</pre>

<p>This example shows a jaggard array. Note each row is a different length.</p>

<pre>
    <font color="#006600">//Jaggered array</font>
    aryPlain <font color="#FF0000">=</font> <font color="#0088FF">new</font> <font color="#0088FF">int</font> <font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font> <font color="#FF0000">{</font> <font color="#FF0000">{</font> <font color="#6600FF">1</font><font color="#FF0000">,</font>  <font color="#6600FF">2</font><font color="#FF0000">,</font>  <font color="#6600FF">3</font><font color="#FF0000">,</font> <font color="#6600FF">5</font><font color="#FF0000">,</font> <font color="#6600FF">6</font><font color="#FF0000">,</font> <font color="#6600FF">7</font><font color="#FF0000">,</font> <font color="#6600FF">8</font><font color="#FF0000">,</font> <font color="#6600FF">9</font> <font color="#FF0000">}</font><font color="#FF0000">,</font>
                              <font color="#FF0000">{</font> <font color="#6600FF">1</font> <font color="#FF0000">}</font><font color="#FF0000">,</font>
                              <font color="#FF0000">{</font> <font color="#6600FF">1</font><font color="#FF0000">,</font>  <font color="#6600FF">2</font><font color="#FF0000">,</font>  <font color="#6600FF">3</font><font color="#FF0000">,</font> <font color="#6600FF">5</font> <font color="#FF0000">}</font><font color="#FF0000">,</font>
                              <font color="#FF0000">{</font> <font color="#6600FF">1</font><font color="#FF0000">,</font>  <font color="#6600FF">2</font><font color="#FF0000">,</font>  <font color="#6600FF">3</font><font color="#FF0000">,</font> <font color="#6600FF">5</font><font color="#FF0000">,</font> <font color="#6600FF">6</font><font color="#FF0000">,</font> <font color="#6600FF">7</font> <font color="#FF0000">}</font> <font color="#FF0000">}</font><font color="#FF0000">;</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nRow <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nRow <font color="#FF0000"><</font> aryPlain.length<font color="#FF0000">;</font> nRow<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        System.out.println<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nCol <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nCol <font color="#FF0000"><</font> aryPlain<font color="#FF0000">[</font>nRow<font color="#FF0000">]</font>.length<font color="#FF0000">;</font> nCol<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
            System.out.print<font color="#FF0000">(</font> aryPlain<font color="#FF0000">[</font>nRow<font color="#FF0000">]</font><font color="#FF0000">[</font>nCol<font color="#FF0000">]</font> <font color="#FF0000">+</font> <font color="#FF00FF">" "</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
</pre>

<p>The last example shows a three dimensinal array that is declared
and populated as we go.</p>

<pre>
    <font color="#006600">//Three dimensional array declared as we go</font>
    <font color="#0088FF">int</font> aryXYZ<font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    aryXYZ <font color="#FF0000">=</font> <font color="#0088FF">new</font> <font color="#0088FF">int</font> <font color="#FF0000">[</font><font color="#6600FF">5</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nX <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nX <font color="#FF0000"><</font> aryXYZ.length<font color="#FF0000">;</font> nX<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font> <font color="#FF0000">=</font> <font color="#0088FF">new</font> <font color="#0088FF">int</font><font color="#FF0000">[</font><font color="#6600FF">3</font><font color="#FF0000">]</font><font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nY <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nY <font color="#FF0000"><</font> aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font>.length<font color="#FF0000">;</font> nY<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font><font color="#FF0000">[</font>nY<font color="#FF0000">]</font> <font color="#FF0000">=</font> <font color="#0088FF">new</font> <font color="#0088FF">int</font><font color="#FF0000">[</font><font color="#6600FF">10</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
            <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nZ <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nZ <font color="#FF0000"><</font> aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font><font color="#FF0000">[</font>nY<font color="#FF0000">]</font>.length<font color="#FF0000">;</font> nZ<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
                aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font><font color="#FF0000">[</font>nY<font color="#FF0000">]</font><font color="#FF0000">[</font>nZ<font color="#FF0000">]</font> <font color="#FF0000">=</font> nX<font color="#FF0000">*</font>nY<font color="#FF0000">*</font>nZ<font color="#FF0000">;</font>
        <font color="#FF0000">}</font>                
    <font color="#FF0000">}</font>
...
    <font color="#006600">//Display X x Y and Z total</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nX <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nX <font color="#FF0000"><</font> aryXYZ.length<font color="#FF0000">;</font> nX<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        System.out.println<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nY <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nY <font color="#FF0000"><</font> aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font>.length<font color="#FF0000">;</font> nY<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            <font color="#0088FF">int</font> nTotal <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
            <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nZ <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nZ <font color="#FF0000"><</font> aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font><font color="#FF0000">[</font>nY<font color="#FF0000">]</font>.length<font color="#FF0000">;</font> nZ<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
                nTotal <font color="#FF0000">+</font><font color="#FF0000">=</font> aryXYZ<font color="#FF0000">[</font>nX<font color="#FF0000">]</font><font color="#FF0000">[</font>nY<font color="#FF0000">]</font><font color="#FF0000">[</font>nZ<font color="#FF0000">]</font><font color="#FF0000">;</font>
            DecimalFormat df <font color="#FF0000">=</font> <font color="#0088FF">new</font> DecimalFormat<font color="#FF0000">(</font> <font color="#FF00FF">"000"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            System.out.print<font color="#FF0000">(</font> df.format<font color="#FF0000">(</font>nTotal<font color="#FF0000">)</font> <font color="#FF0000">+</font> <font color="#FF00FF">"  "</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
</pre>


<h4>Collections.</h4>

<p>JDK 1.0 to JDK 1.2. Somebody just don't seem to be able to get collections
right. As each new version of the language arrives a new set of names comes out
for collections and other methods are added and Deprecated. This example
seems to work with VJ++ using java 1.1.4. But now <code>Vector</code> has 
been replaced with <code>ArrayList</code> so check the documentation
and ensure JVM supports the commands you are using.</p> 

<p> There are three types of collections.</p>
<TABLE align=center border=1 cellPadding=2 cellSpacing=0>
    <TR>
        <TD bgcolor=powderblue width=100>
            <P align=center>interface</P></TD>
        <TD bgcolor=powderblue width=150>
            <P align=center>concrete class</P></TD>
        <TD bgcolor=powderblue width=150>
            <P align=center>Allow Duplicates</P></TD>
        <TD bgcolor=powderblue width=150>
            <P align=center>Ordered</P></TD></TR>
    <TR>
        <TD>Collection</TD>
        <TD>&nbsp;</TD>
        <TD><P align=center>Yes</P></TD>
        <TD>
      <P align=center>No</P></TD></TR>
    <TR>
        <TD>Set</TD>
        <TD>HashSet</TD>
        <TD><P align=center>No</P></TD>
        <TD>
      <P align=center>Yes</P></TD></TR>
    <TR>
        <TD>List</TD>
        <TD>ArrayList(LinkedList)</TD>
        <TD><P align=center>Yes</P></TD>
        <TD>
      <P align=center>Yes</P></TD></TR>
</TABLE>

<h4>Map (HashMap)</h4>

<p>A HashMap is a collection of key and value pairs so items can
be quickly located using the key.</p>

<h4>Vector (ArrayList)</h4>

<p>In this examplle the list is populated with an <i>unknown at 
compile time</i> number of items. Later the elements are recalled
and displayed. JDK 1.2 would use <code>add</code> and <code>get</code>
to insert and retrieve the data.</p>

<pre>
<font color="#0088FF">import</font> java.lang.Math<font color="#FF0000">;</font>
<font color="#0088FF">import</font> java.util.Vector<font color="#FF0000">;</font>
...
    <font color="#006600">//Populate the collection</font>
    Vector listSquareRoots <font color="#FF0000">=</font> <font color="#0088FF">new</font> Vector<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">int</font> nSquare <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
    <font color="#0088FF">double</font> dRoot<font color="#FF0000">;</font>
    <font color="#0088FF">do</font>
    <font color="#FF0000">{</font>
        dRoot <font color="#FF0000">=</font> Math.sqrt<font color="#FF0000">(</font> nSquare<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        listSquareRoots.addElement<font color="#FF0000">(</font> <font color="#0088FF">new</font> Double<font color="#FF0000">(</font>dRoot<font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>        
    <font color="#FF0000">}</font> <font color="#0088FF">while</font><font color="#FF0000">(</font> dRoot <font color="#FF0000"><</font> <font color="#6600FF">4.0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

...
    
    <font color="#006600">//Display the collection</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> n <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> n <font color="#FF0000"><</font> listSquareRoots.size<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font> n<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF0000">(</font>Double<font color="#FF0000">)</font>listSquareRoots.elementAt<font color="#FF0000">(</font> n <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<h4>Enumeration / Iterators.</h4>

<p>Enumeration has now been replaced with Iterator in JDK 1.2.
As time goes by this will probably change again so check your
target platform before using the latest class.</p>

<p>The following code uses the an iterator to move through
the list populated in the previous example.</p>

<pre>
<font color="#0088FF">import</font> java.util.Enumeration<font color="#FF0000">;</font>
...
    <font color="#006600">//Display the list using an iterator</font>
    Enumeration enum <font color="#FF0000">=</font> listSquareRoots.elements<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> enum.hasMoreElements<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF0000">(</font>Double<font color="#FF0000">)</font>enum.nextElement<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




