
<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h4>Description.</h4>
      
<p>Displaying a modal dialog can be handy for such things as
about box and warning message boxes. This <code>SimpleDialog</code>
class displays a Dialog box with a text area in it.</p>
   
<h4>Simple Dialog class</h4>

The class loads and creates an action listener to destroy
itself when the the close is selected. It also add a text
area to display the data in the dialog.

<pre>
<font color="#006600">/////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//Modal Dialog box used to display a modal about box</font>
<font color="#0088FF">class</font> SimpleDialog <font color="#0088FF">extends</font> Dialog
<font color="#FF0000">{</font>
    <font color="#006600">//Attributes</font>
    <font color="#0088FF">private</font> TextArea m_textArea<font color="#FF0000">;</font>

    <font color="#006600">//Constructor</font>
    <font color="#0088FF">public</font> SimpleDialog<font color="#FF0000">(</font> Frame fParent<font color="#FF0000">,</font> String sTitle <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">super</font><font color="#FF0000">(</font> fParent<font color="#FF0000">,</font> sTitle<font color="#FF0000">,</font> <font color="#0088FF">true</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>   
    
    <font color="#006600">//Layout and show the dialog</font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> show<font color="#FF0000">(</font> String sText <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        <font color="#006600">//Add anonymous class handler to Close dialog with close button</font>
        addWindowListener <font color="#FF0000">(</font> 
            <font color="#0088FF">new</font> WindowAdapter<font color="#FF0000">(</font><font color="#FF0000">)</font>
            <font color="#FF0000">{</font>
                <font color="#0088FF">public</font> <font color="#0088FF">void</font> windowClosing<font color="#FF0000">(</font> WindowEvent e <font color="#FF0000">)</font> 
                <font color="#FF0000">{</font>           
                    <font color="#0088FF">if</font><font color="#FF0000">(</font> e.getSource<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#0088FF">instanceof</font> SimpleDialog <font color="#FF0000">)</font>
                    <font color="#FF0000">{</font>
                        SimpleDialog sd <font color="#FF0000">=</font> <font color="#FF0000">(</font>SimpleDialog<font color="#FF0000">)</font><font color="#FF0000">(</font> e.getSource<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
                        sd.dispose<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
                    <font color="#FF0000">}</font>
                    <font color="#0088FF">else</font>
                    <font color="#FF0000">{</font>
                        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"***ERROR event recieved for wrong window "</font> <font color="#FF0000">+</font> e <font color="#FF0000">)</font><font color="#FF0000">;</font>
                    <font color="#FF0000">}</font>
                <font color="#FF0000">}</font>
            <font color="#FF0000">}</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        m_textArea <font color="#FF0000">=</font> <font color="#0088FF">new</font> TextArea<font color="#FF0000">(</font> sText <font color="#FF0000">)</font><font color="#FF0000">;</font>
        setSize<font color="#FF0000">(</font> <font color="#6600FF">200</font><font color="#FF0000">,</font> <font color="#6600FF">100</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        add<font color="#FF0000">(</font> m_textArea <font color="#FF0000">)</font><font color="#FF0000">;</font>
        show<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>                         <font color="#006600">//This is a blocking call</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

This is how to use the call the dialog. We create a simple frame with two
buttons, one to activate the Dialog and one to quite the application.

<pre>
<font color="#0088FF">import</font> java.awt.<font color="#FF0000">*</font><font color="#FF0000">;</font>
<font color="#0088FF">import</font> java.awt.event.<font color="#FF0000">*</font><font color="#FF0000">;</font>

<font color="#006600">/////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//Typical Class that catchs a button event and display</font>
<font color="#006600">//a modal dialog box.</font>
<font color="#0088FF">public</font> <font color="#0088FF">class</font> DialogTest <font color="#0088FF">extends</font> Frame <font color="#0088FF">implements</font> ActionListener
<font color="#FF0000">{</font>
    <font color="#006600">//Attributes</font>
    <font color="#0088FF">private</font> Button  m_btnDialog<font color="#FF0000">;</font>
    <font color="#0088FF">private</font> Button  m_btnQuit<font color="#FF0000">;</font>

    <font color="#006600">//Main application starts here</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">void</font> main <font color="#FF0000">(</font>String<font color="#FF0000">[</font><font color="#FF0000">]</font> args<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        DialogTest frame <font color="#FF0000">=</font> <font color="#0088FF">new</font> DialogTest<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        frame.setTitle<font color="#FF0000">(</font> <font color="#FF00FF">"Testing Dialog!"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        frame.SetupMain<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//Setup initial </font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> SetupMain<font color="#FF0000">(</font><font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        setLayout<font color="#FF0000">(</font> <font color="#0088FF">new</font> FlowLayout<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        m_btnDialog <font color="#FF0000">=</font> <font color="#0088FF">new</font> Button<font color="#FF0000">(</font> <font color="#FF00FF">"About"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        m_btnDialog.addActionListener<font color="#FF0000">(</font> <font color="#0088FF">this</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        m_btnQuit <font color="#FF0000">=</font> <font color="#0088FF">new</font> Button<font color="#FF0000">(</font> <font color="#FF00FF">"Quit"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        m_btnQuit.addActionListener<font color="#FF0000">(</font> <font color="#0088FF">this</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        add<font color="#FF0000">(</font> m_btnDialog <font color="#FF0000">)</font><font color="#FF0000">;</font>
        add<font color="#FF0000">(</font> m_btnQuit <font color="#FF0000">)</font><font color="#FF0000">;</font>
        pack<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        setVisible<font color="#FF0000">(</font> <font color="#0088FF">true</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//Event handler (For button press only)</font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> actionPerformed<font color="#FF0000">(</font>ActionEvent e<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Display Dialog if Button is pressed</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> e.getSource<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> m_btnDialog <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            SimpleDialog simdlg <font color="#FF0000">=</font> <font color="#0088FF">new</font> SimpleDialog<font color="#FF0000">(</font> <font color="#0088FF">this</font><font color="#FF0000">,</font> <font color="#FF00FF">"About box"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            simdlg.show<font color="#FF0000">(</font> <font color="#FF00FF">"Application by John McTainsh\n"</font> <font color="#FF0000">+</font>
                         <font color="#FF00FF">"Written 26 October 2000."</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#006600">//Quite if Button is pressed</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> e.getSource<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> m_btnQuit <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            System.exit<font color="#FF0000">(</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

NOTE: When running the Microsoft virtual machine <code>JView.exe</code> 
you may be able to click on the "About" button several times before
the first instance of the About box appears so several About boxes
may appear on top of each other. This does not happen on the 
SUN virtual machine. To overcome this prevent the Dialog
displaying if it is already visible. ie

<pre>
    ...
    <font color="#006600">//Event handler (For button press only)</font>
    SimpleDialog m_SimDlg <font color="#FF0000">=</font> <font color="#0088FF">null</font><font color="#FF0000">;</font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> actionPerformed<font color="#FF0000">(</font>ActionEvent e<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Display Dialog if Button is pressed</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> e.getSource<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> m_btnDialog <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            <font color="#0088FF">if</font><font color="#FF0000">(</font> m_SimDlg <font color="#FF0000">!</font><font color="#FF0000">=</font> <font color="#0088FF">null</font> <font color="#FF0000">)</font>
                <font color="#0088FF">return</font><font color="#FF0000">;</font>
            m_SimDlg <font color="#FF0000">=</font> <font color="#0088FF">new</font> SimpleDialog<font color="#FF0000">(</font> <font color="#0088FF">this</font><font color="#FF0000">,</font> <font color="#FF00FF">"About box"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            m_SimDlg.show<font color="#FF0000">(</font> <font color="#FF00FF">"Application by John McTainsh\n"</font> <font color="#FF0000">+</font>
                         <font color="#FF00FF">"Written 26 October 2000."</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            m_SimDlg <font color="#FF0000">=</font> <font color="#0088FF">null</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    ...
</pre>

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




