
<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h4>Description.</h4>
      
<p>Every application needs to start somewhere so here is the frame work for 
the simplest window application. It creates a main window with a title bar.</p>
   
<h4>How it does this.</h4>

<p>The <code>main</code> functions creates an instance of a <code>Frame</code> 
derived class <code>ColourCode</code>. <code>initFrame</code> is called to 
create and display the window. It also adds an 
event handler to catch requests to close and call exit appropriately.</p>

<pre>
<font color="#0088FF">import</font> java.awt.<font color="#FF0000">*</font><font color="#FF0000">;</font>
<font color="#0088FF">import</font> java.awt.event.<font color="#FF0000">*</font><font color="#FF0000">;</font>

<font color="#006600">/////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//Class extends the frame class to display the main application frame</font>
<font color="#0088FF">public</font> <font color="#0088FF">class</font> ColourCode <font color="#0088FF">extends</font> Frame
<font color="#FF0000">{</font>
    <font color="#006600">/////////////////////////////////////////////////////////////////////////</font>
    <font color="#006600">//Application starts here</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">void</font> main <font color="#FF0000">(</font>String<font color="#FF0000">[</font><font color="#FF0000">]</font> args<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        ColourCode frame <font color="#FF0000">=</font> <font color="#0088FF">new</font> ColourCode<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        frame.initFrame<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
        
    <font color="#006600">/////////////////////////////////////////////////////////////////////////</font>
    <font color="#006600">//Setup the Main window</font>
    <font color="#0088FF">private</font> <font color="#0088FF">void</font> initFrame<font color="#FF0000">(</font><font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Add an anonymous event handler to shut down on exit</font>
        addWindowListener<font color="#FF0000">(</font> <font color="#0088FF">new</font> WindowAdapter<font color="#FF0000">(</font><font color="#FF0000">)</font>
            <font color="#FF0000">{</font>
                <font color="#0088FF">public</font> <font color="#0088FF">void</font> windowClosing<font color="#FF0000">(</font> WindowEvent ew <font color="#FF0000">)</font>
                <font color="#FF0000">{</font>
                    System.exit<font color="#FF0000">(</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
                <font color="#FF0000">}</font>
            <font color="#FF0000">}</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        
        <font color="#006600">//Set the window Size and title</font>
        setTitle<font color="#FF0000">(</font> <font color="#FF00FF">"Code to Colour HTML"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        setSize<font color="#FF0000">(</font> <font color="#6600FF">400</font><font color="#FF0000">,</font> <font color="#6600FF">200</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        setVisible<font color="#FF0000">(</font> <font color="#0088FF">true</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>


<!-- #include virtual="/Inc/NoteFooter.inc" --> 




