
<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h4>Description.</h4>
      
<p>File IO forms some part of most applications today. It is simple to 
perform and easy way to make persistent data. This note persistent
how to read text from and write text to a file.</p>
   
<h4>The functions and how to use them.</h4>

<p>Lets first introduce the functions.</p>

<pre>
    <font color="#006600">/**
     * Load the file into a StringBuffer for processing
     * @param sFileName   The fully qualified name of the file
     * @param sData       The text read from the file or
     *                    the exception description if an error occured.
     * @return            True if the read was sucessful
     */</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">boolean</font> loadFile<font color="#FF0000">(</font> String sFileName<font color="#FF0000">,</font> StringBuffer sData <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">try</font>
        <font color="#FF0000">{</font>            
            FileReader fr <font color="#FF0000">=</font> <font color="#0088FF">new</font> FileReader<font color="#FF0000">(</font> sFileName <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">char</font> <font color="#FF0000">[</font><font color="#FF0000">]</font> aryData <font color="#FF0000">=</font> <font color="#0088FF">new</font> <font color="#0088FF">char</font><font color="#FF0000">[</font><font color="#6600FF">1000</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
            
            <font color="#006600">//Keep reading until no more data remains</font>
            <font color="#0088FF">while</font><font color="#FF0000">(</font> <font color="#0088FF">true</font> <font color="#FF0000">)</font>
            <font color="#FF0000">{</font>
                <font color="#0088FF">int</font> nRead <font color="#FF0000">=</font> fr.read<font color="#FF0000">(</font> aryData <font color="#FF0000">)</font><font color="#FF0000">;</font>
                <font color="#0088FF">if</font><font color="#FF0000">(</font> nRead <font color="#FF0000"><</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
                <font color="#FF0000">{</font>
                    <font color="#0088FF">break</font><font color="#FF0000">;</font>
                <font color="#FF0000">}</font>
                sData.append<font color="#FF0000">(</font> aryData<font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> nRead <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#FF0000">}</font>
            fr.close<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#006600">//Catch any IO exceptions and put them in the return string</font>
        <font color="#0088FF">catch</font><font color="#FF0000">(</font> IOException  ioe <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            sData.append<font color="#FF0000">(</font> ioe <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>

    
    <font color="#006600">/**
     * Write the given data to sFileNamme
     * @param sFileName   The fully qualified name of the file
     * @param sData       The text to write to the file.
     * @return            True if the write was sucessful
     */</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">boolean</font> saveFile<font color="#FF0000">(</font> String sFileName<font color="#FF0000">,</font> String sData <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">try</font>
        <font color="#FF0000">{</font>            
            FileWriter fw <font color="#FF0000">=</font> <font color="#0088FF">new</font> FileWriter<font color="#FF0000">(</font> sFileName <font color="#FF0000">)</font><font color="#FF0000">;</font>            
            fw.write<font color="#FF0000">(</font> sData<font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> sData.length<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            fw.flush<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            fw.close<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#006600">//Catch any IO exceptions and put them in the return string</font>
        <font color="#0088FF">catch</font><font color="#FF0000">(</font> IOException  ioe <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>        
</pre>

<p>Now lets use them. Read text from one file and write it
to another.</p>

<pre>
    StringBuffer sFileData <font color="#FF0000">=</font> <font color="#0088FF">new</font> StringBuffer<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> loadFile<font color="#FF0000">(</font> <font color="#FF00FF">"C:\\Temp\\Master.txt , sFileData );</font>
        saveFile<font color="#FF0000">(</font> <font color="#FF00FF">"C:\\Temp\\Master.bak , sFileData.toString() );</font>
    <font color="#0088FF">else</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Error: "</font> <font color="#FF0000">+</font> sFileData.toString<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




