
<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h4>Description.</h4>
      
<p>    Threads are an important and tricky part of a multi tasking operating system. 
This article will show how to use threads and mutex but will not details thread 
design issues such as Deadlock and Spinlock.</p>
   
<h4>Simpe implements Runnable thread.</h4>

A simple way to implement a thread is to put it in the same class by 
implementing the Runnable interface as follows.

<pre>
<font color="#006600">/////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//Class implements a the Runnable interface to create a simple thread</font>
<font color="#0088FF">public</font> <font color="#0088FF">class</font> ThreadTester <font color="#0088FF">implements</font> Runnable
<font color="#FF0000">{</font>
    <font color="#006600">//Application runs from here</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">void</font> main<font color="#FF0000">(</font> String<font color="#FF0000">[</font><font color="#FF0000">]</font> sArgs <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        <font color="#006600">//Create the thread object</font>
        ThreadTester runner <font color="#FF0000">=</font> <font color="#0088FF">new</font> ThreadTester<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        Thread thread <font color="#FF0000">=</font> <font color="#0088FF">new</font> Thread<font color="#FF0000">(</font> runner <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
        <font color="#006600">//Run the thread</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"About to Start thread"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        thread.start<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Thread started!"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        
    <font color="#FF0000">}</font>
    
    <font color="#006600">//This is the working part of the thread.</font>
    <font color="#006600">//It will loop 10 times displaying a count then terminate</font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> run<font color="#FF0000">(</font><font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nCnt <font color="#FF0000">=</font> <font color="#6600FF">1</font><font color="#FF0000">;</font> nCnt <font color="#FF0000"><</font><font color="#FF0000">=</font> <font color="#6600FF">10</font><font color="#FF0000">;</font> nCnt<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
            System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Loop #"</font> <font color="#FF0000">+</font> nCnt <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

<h4>Extending two Thread objects</h4>

Sometimes it is simpler to extend the Thread class to create a worker
thread. In this case we have done just that and added a user member variable. 
Extending the Thread class does limit your ability to extend twice 
so sometime your may want to create it as an inner class.


<pre>
<font color="#006600">//////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//Class creates two extensions of Thread and runs them</font>
<font color="#0088FF">public</font> <font color="#0088FF">class</font> ThreadTester
<font color="#FF0000">{</font>
    <font color="#006600">//Application runs from here</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">void</font> main<font color="#FF0000">(</font> String<font color="#FF0000">[</font><font color="#FF0000">]</font> sArgs <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        <font color="#006600">//Create the thread object</font>
        WorkerThread worker1 <font color="#FF0000">=</font> <font color="#0088FF">new</font> WorkerThread<font color="#FF0000">(</font> <font color="#FF00FF">"Fred"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        WorkerThread worker2 <font color="#FF0000">=</font> <font color="#0088FF">new</font> WorkerThread<font color="#FF0000">(</font> <font color="#FF00FF">"Barry"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
        <font color="#006600">//Run the thread</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"About to Start thread"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        worker1.start<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        worker2.start<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Thread started!"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>   
<font color="#FF0000">}</font>


<font color="#006600">//////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//This is a ninner class the provides a worker thread</font>
<font color="#0088FF">class</font> WorkerThread <font color="#0088FF">extends</font> Thread
<font color="#FF0000">{</font>
    <font color="#0088FF">private</font> String m_sUser<font color="#FF0000">;</font>
    
    <font color="#006600">//Constructor</font>
    <font color="#0088FF">public</font> WorkerThread<font color="#FF0000">(</font> String sUser <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        m_sUser <font color="#FF0000">=</font> sUser<font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//This is the working part of the thread.</font>
    <font color="#006600">//It will loop 10 times displaying a count then terminate</font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> run<font color="#FF0000">(</font><font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nCnt <font color="#FF0000">=</font> <font color="#6600FF">1</font><font color="#FF0000">;</font> nCnt <font color="#FF0000"><</font><font color="#FF0000">=</font> <font color="#6600FF">10</font><font color="#FF0000">;</font> nCnt<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
            System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Loop ("</font> <font color="#FF0000">+</font> m_sUser <font color="#FF0000">+</font> <font color="#FF00FF">") #"</font> <font color="#FF0000">+</font> nCnt <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>


<h4>Thread syncronisation.</h4>

As not all objects are "thread safe" (able to be processed by two 
threads at the same time) it is often necessary to stop processing
in a certain area until another thread is finished in that area. In the
example that follows <code>m_nCounter</code> is incremented after an exact match
test is performed. If both threads increment <code>m_nCounter</code> at
the same time 33 could be missed. The <code>synchronized</code> keyword 
prevents this happening.

<pre>
<font color="#006600">//////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//Class uses synchronsation</font>
<font color="#0088FF">public</font> <font color="#0088FF">class</font> ThreadTester <font color="#0088FF">extends</font> Thread
<font color="#FF0000">{</font>
    <font color="#006600">//Attributes</font>
    <font color="#0088FF">private</font> <font color="#0088FF">int</font> m_nCounter <font color="#FF0000">=</font> <font color="#6600FF">1</font><font color="#FF0000">;</font>
    <font color="#0088FF">private</font> String m_sName<font color="#FF0000">;</font>
                            
    <font color="#006600">//Application runs from here</font>
    <font color="#0088FF">public</font> <font color="#0088FF">static</font> <font color="#0088FF">void</font> main<font color="#FF0000">(</font> String<font color="#FF0000">[</font><font color="#FF0000">]</font> sArgs <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        <font color="#006600">//Create the thread object</font>
        ThreadTester worker1 <font color="#FF0000">=</font> <font color="#0088FF">new</font> ThreadTester<font color="#FF0000">(</font> <font color="#FF00FF">"Fred"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        ThreadTester worker2 <font color="#FF0000">=</font> <font color="#0088FF">new</font> ThreadTester<font color="#FF0000">(</font> <font color="#FF00FF">"Barry"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
        <font color="#006600">//Run the thread</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"About to Start threads"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        worker1.start<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        worker2.start<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Threads started!"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//Constructor</font>
    <font color="#0088FF">public</font> ThreadTester<font color="#FF0000">(</font> String sName <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        m_sName <font color="#FF0000">=</font> sName<font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//Synchronised function (Only one thread can be in here at any instant</font>
    <font color="#0088FF">private</font> <font color="#0088FF">synchronized</font> <font color="#0088FF">boolean</font> areWeDone<font color="#FF0000">(</font><font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        <font color="#0088FF">if</font><font color="#FF0000">(</font> m_nCounter <font color="#FF0000">=</font><font color="#FF0000">=</font> <font color="#6600FF">33</font> <font color="#FF0000">)</font>
            <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
        m_nCounter<font color="#FF0000">+</font><font color="#FF0000">+</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//This is the working part of the thread.</font>
    <font color="#006600">//It will loop 10 times displaying a count then terminate</font>
    <font color="#0088FF">public</font> <font color="#0088FF">void</font> run<font color="#FF0000">(</font><font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">int</font> nCnt <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
        <font color="#0088FF">while</font><font color="#FF0000">(</font> <font color="#FF0000">!</font>areWeDone<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            System.out.println<font color="#FF0000">(</font> <font color="#FF00FF">"Loop ("</font> <font color="#FF0000">+</font> m_sName <font color="#FF0000">+</font> <font color="#FF00FF">") #"</font> <font color="#FF0000">+</font> nCnt<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

If <code>m_nCounter</code> was read in one place and incremented in another
part of the SAME class the <code>synchronized( this )</code> wrapper can be used
to control synchronisation within the SAME class. 

<pre>
    <font color="#0088FF">synchronized</font><font color="#FF0000">(</font> <font color="#0088FF">this</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        <font color="#0088FF">if</font><font color="#FF0000">(</font> m_nCounter <font color="#FF0000">=</font><font color="#FF0000">=</font> <font color="#6600FF">33</font> <font color="#FF0000">)</font>
            <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    
    <font color="#006600">//... Somewhere alse in the SAME class.</font>
    <font color="#0088FF">synchronized</font><font color="#FF0000">(</font> <font color="#0088FF">this</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>       
        m_nCounter<font color="#FF0000">+</font><font color="#FF0000">+</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
</pre>

No other thread can enter ANY <code>synchronized( this )</code> 
<u>section</u> in the class until ALL the <code>synchronized( this )</code> 
<u>sections</u> in that class have been exited by all threads.

<p>In contrast to this, other threads can occupy other <code>synchronized</code> 
<u>functions</u> in the same class but two threads CAN NOT occupy the 
same <code>synchronized</code> <u>function</u> at the same time.</p>


<!-- #include virtual="/Inc/NoteFooter.inc" --> 




