


<!-- #include virtual="/Inc/NoteHeader.inc" --> 


      <h4>Description.</h4>
      
      <p>As the user tabs or moves from edit box to edit box in a form or dialog it
      can be dificult to see which box has focus. To help the user it is nice
      to see the selected edit box highlighted in a different colour. 
      
      <br>
      <br>
      <img border="0" src="CEditBackground.gif" width="327" height="93">
      
      
      <h4>How to do this.</h4>

		Add a class member variable.
<pre>
    HBRUSH m_hbr<font color="#FF0000">;</font>
</pre>
		In the constructor for the window add.	
<pre>
    VERIFY<font color="#FF0000">(</font> m_hbr <font color="#FF0000">=</font> CreateSolidBrush<font color="#FF0000">(</font> RGB<font color="#FF0000">(</font> <font color="#6600FF">255</font><font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>		
		In the destructor for the window add.	
<pre>
    DeleteObject<font color="#FF0000">(</font> m_hbr <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>		
      <p>the Form or Dialog class using the class wizard add message handlers for <code>OnCommand</code> 
		and <code>WM_CTLCOLOR</code> replace the wizard generated code with the following.</p>
      
<pre>
<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      Catch SetFocus and KillFocus to highlight the window that</font>
<font color="#006600">//      is currently active.</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      See Help</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//      See Help</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//      4-10-2000, 12:04:27 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
BOOL CWxyzView<font color="#FF0000">:</font><font color="#FF0000">:</font>OnCommand<font color="#FF0000">(</font>WPARAM wParam<font color="#FF0000">,</font> LPARAM lParam<font color="#FF0000">)</font> 
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CWxyzView::OnCommand(%d,%ld) \n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> wParam<font color="#FF0000">,</font> lParam <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#006600">//</font>
    <font color="#006600">//Refresh the Display when a Control gets or looses focus</font>
    <font color="#006600">//</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> <font color="#FF0000">(</font> HIWORD<font color="#FF0000">(</font> wParam <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> EN_SETFOCUS <font color="#FF0000">)</font> <font color="#FF0000">|</font><font color="#FF0000">|</font>
        <font color="#FF0000">(</font> HIWORD<font color="#FF0000">(</font> wParam <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> EN_KILLFOCUS <font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        UINT nID <font color="#FF0000">=</font> LOWORD<font color="#FF0000">(</font> wParam <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> nID <font color="#FF0000">!</font><font color="#FF0000">=</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            CWnd<font color="#FF0000">*</font> pWnd <font color="#FF0000">=</font> GetDlgItem<font color="#FF0000">(</font> nID <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">if</font><font color="#FF0000">(</font> pWnd <font color="#FF0000">!</font><font color="#FF0000">=</font> NULL <font color="#FF0000">)</font>
            <font color="#FF0000">{</font>
                pWnd<font color="#FF0000">-</font><font color="#FF0000">></font>Invalidate<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#FF0000">}</font>
        <font color="#FF0000">}</font>    
    <font color="#FF0000">}</font>
    <font color="#0088FF">return</font> CFormView<font color="#FF0000">:</font><font color="#FF0000">:</font>OnCommand<font color="#FF0000">(</font>wParam<font color="#FF0000">,</font> lParam<font color="#FF0000">)</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>

<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//        Setup screen colours for the Edit boxes</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//        See help</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//        See Help</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//        4-10-2000, 13:57:07 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
HBRUSH CWxyzView<font color="#FF0000">:</font><font color="#FF0000">:</font>OnCtlColor<font color="#FF0000">(</font>CDC<font color="#FF0000">*</font> pDC<font color="#FF0000">,</font> CWnd<font color="#FF0000">*</font> pWnd<font color="#FF0000">,</font> UINT nCtlColor<font color="#FF0000">)</font> 
<font color="#FF0000">{</font>
    HBRUSH hbr <font color="#FF0000">=</font> CFormView<font color="#FF0000">:</font><font color="#FF0000">:</font>OnCtlColor<font color="#FF0000">(</font>pDC<font color="#FF0000">,</font> pWnd<font color="#FF0000">,</font> nCtlColor<font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Change edit boxes only</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> nCtlColor <font color="#FF0000">=</font><font color="#FF0000">=</font> CTLCOLOR_EDIT <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//If it has the focus then change the text and background</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> pDC<font color="#FF0000">-</font><font color="#FF0000">></font>GetWindow<font color="#FF0000">(</font> <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> GetFocus<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            pDC<font color="#FF0000">-</font><font color="#FF0000">></font>SetTextColor<font color="#FF0000">(</font> RGB<font color="#FF0000">(</font> <font color="#6600FF">255</font><font color="#FF0000">,</font> <font color="#6600FF">255</font><font color="#FF0000">,</font> <font color="#6600FF">255</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            pDC<font color="#FF0000">-</font><font color="#FF0000">></font>SetBkColor<font color="#FF0000">(</font> RGB<font color="#FF0000">(</font> <font color="#6600FF">255</font><font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            DeleteObject<font color="#FF0000">(</font> hbr <font color="#FF0000">)</font><font color="#FF0000">;</font>
            hbr <font color="#FF0000">=</font> m_hbr<font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">return</font> hbr<font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>      



<!-- #include virtual="/Inc/NoteFooter.inc" --> 




