


<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h1>Introduction.</h1>
      
<p>This turorial will demonstrate the the MFC collection classes <code>
CList, CArray </code>and<code> CMap</code>. These classes are an excillent way
to manage dynamic data in a type safe manner. They are very easy to use
and <i>mostly</i> encourage solid code.</p>


<a href="#_QuickStart"			>Quick Start.</a><br>
<a href="#_CollectionDataTypes"	>Collection Data Types.</a><br>
<a href="#_UsingCArray"			>Using CArray.</a><br>
<a href="#_UsingCList"			>Using CList.</a><br>
<a href="#_UsingCMap"			>Using CMap.</a><br>
<a href="#_UsingPointers"		>Using pointers to objects.</a><br>

<a name="_QuickStart"></a>
<h1>A Quick Start.</h1>

<p>Lets just use a simple List collection to start with. This example 
demonstartes a que of shoe sizes held as doubles. Items are added to the
Tail of the que and removed from the Head for processing.</p>

<pre>
<font color="#0088FF">#include</font> <font color="#FF0000"><</font>afxtempl.h<font color="#FF0000">></font>       <font color="#006600">// MFC suport for Collections</font>
...
    <font color="#006600">//Declare the que object</font>
    CList<font color="#FF0000"><</font><font color="#0088FF">double</font><font color="#FF0000">,</font> <font color="#0088FF">double</font><font color="#FF0000">></font> m_lstShoeSize<font color="#FF0000">;</font>

    <font color="#006600">//Add items to the que</font>
    m_lstShoeSize.AddTail<font color="#FF0000">(</font> <font color="#6600FF">10.5</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstShoeSize.AddTail<font color="#FF0000">(</font>  <font color="#6600FF">8.0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstShoeSize.AddTail<font color="#FF0000">(</font>  <font color="#6600FF">9.5</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstShoeSize.AddTail<font color="#FF0000">(</font>  <font color="#6600FF">9.0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Process (show) the items in the list.</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> POSITION pos <font color="#FF0000">=</font> m_lstShoeSize.GetHeadPosition<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font> pos <font color="#FF0000">!</font><font color="#FF0000">=</font> NULL<font color="#FF0000">;</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Shoe size is %4.1lf\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> m_lstShoeSize.GetNext<font color="#FF0000">(</font> pos <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>

    <font color="#006600">//Process (remove) the items from the que</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> <font color="#FF0000">!</font>m_lstShoeSize.IsEmpty<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">double</font> dRemovedShoe <font color="#FF0000">=</font> m_lstShoeSize.RemoveHead<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Removing Shoe Size(%4.1lf)\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> dRemovedShoe <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>

</pre>


<a name="_CollectionDataTypes"></a>
<h1>Collection data types.</h1>

<p>Jump ahead to <a href="#_UsingCArray">using CArray</a> if you
just want to skip the theory. In the previous example you would note the
use of a template <code><double, double></code>. The two parameters
<code><TYPE,ARG_TYPE></code> are used to define how data is stored
and retrieved from the collection.</p>

<h2>TYPE.</h2>

<p>This is the type of data that is used to hold the elements 
internally and RETURNED from the collection. Get returns this
data type.</p>

<h2>ARG_TYPE.</h2>

<p>This type is use to specify the type of data used to write (STORE) data
to the collection. Set uses this data type. Often this type is a
reference to the TYPE value. Some examples follow;</p>

<pre>
    CList<font color="#FF0000"><</font> PERSON<font color="#FF0000">*</font><font color="#FF0000">,</font> PERSON<font color="#FF0000">*</font> <font color="#FF0000">></font> m_lstPeople<font color="#FF0000">;</font>     <font color="#006600">//1 List of pointers to struct</font>
    CList<font color="#FF0000"><</font> CString<font color="#FF0000">,</font> CString <font color="#FF0000">></font> m_lstNames<font color="#FF0000">;</font>      <font color="#006600">//2 List of CStrings</font>
    CList<font color="#FF0000"><</font> CString<font color="#FF0000">,</font> CString<font color="#FF0000">&</font><font color="#FF0000">></font> m_lstNames<font color="#FF0000">;</font>      <font color="#006600">//3 .. same using references</font>
    CList<font color="#FF0000"><</font> CString<font color="#FF0000">,</font> LPCSTR  <font color="#FF0000">></font> m_lstNames<font color="#FF0000">;</font>      <font color="#006600">//4 .. using constant pointers</font>
</pre>

<p>Note 1: With regard sample 1, the list contains pointer not objects, so 
the objects must be created with new and deleted when no longer
required.</p>

<p>Note 2: With regard sample 3, the ARG_TYPE parameter is used to indicate how the 
value will be passed into the collection, ie in the Add() method. It does NOT 
indicate a collection of referances.</p>


<a name="_UsingCArray"></a>
<h1>Using CArray.</h1>

<p>CArray is a collection that is best used for data that is to
be accessed in a random or non sequensial manner. The array can dynamically 
shrink and grow as necessary.  Array indexes always start at position 0. 
You can decide whether to fix the upper bound or allow the array to expand 
when you add elements past the current bound. Memory is allocated contiguously 
to the upper bound, even if some elements are null.
</p>

<p>The following example adds two CTime objects to the array and then
displays the contents of the entire array. The key functions are <code>SetAtGrow
</code> which adds an item and increases the array size and the <code>[]
</code> operator which is used to retrieve data from the array.</p>

<pre>
<font color="#0088FF">#include</font> <font color="#FF0000"><</font>afxtempl.h<font color="#FF0000">></font>       <font color="#006600">// MFC suport for Collections</font>
...
   CArray<font color="#FF0000"><</font>CTime<font color="#FF0000">,</font> CTime<font color="#FF0000">&</font><font color="#FF0000">></font> m_aryTime<font color="#FF0000">;</font>

    m_aryTime.SetAtGrow<font color="#FF0000">(</font> <font color="#6600FF">3</font><font color="#FF0000">,</font> CTime<font color="#FF0000">:</font><font color="#FF0000">:</font>GetCurrentTime<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_aryTime.SetAtGrow<font color="#FF0000">(</font> <font color="#6600FF">5</font><font color="#FF0000">,</font> CTime<font color="#FF0000">(</font> <font color="#6600FF">1999</font><font color="#FF0000">,</font> <font color="#6600FF">6</font><font color="#FF0000">,</font> <font color="#6600FF">12</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nCnt <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nCnt <font color="#FF0000"><</font> m_aryTime.GetSize<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font> nCnt<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> m_aryTime<font color="#FF0000">[</font>nCnt<font color="#FF0000">]</font>.GetTime<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">!</font><font color="#FF0000">=</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font> 
            _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Time is %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
            m_aryTime<font color="#FF0000">[</font>nCnt<font color="#FF0000">]</font>.Format<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"%d/%b/%y %H:%M"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#0088FF">else</font>
        <font color="#FF0000">{</font>
            _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Invalid Time\n"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
</pre>

<a name="_UsingCList"></a>
<h1>Using CList.</h1>

<p>Lists are simular to arrays but are optimised for data that is read in a more sequensial
manner such as ques and lists. See the example in <a href="#_QuickStart">Quick Start.</a>
earlier for a simple list example. Note items are added at the head or tail of the list.
Retrival is from the head or tail of the list and via an iterative process.</p>

<pre>
<font color="#0088FF">#include</font> <font color="#FF0000"><</font>afxtempl.h<font color="#FF0000">></font>       <font color="#006600">// MFC suport for Collections</font>
...
    <font color="#006600">//Declare the que object</font>
    CList<font color="#FF0000"><</font><font color="#0088FF">int</font><font color="#FF0000">,</font> <font color="#0088FF">int</font><font color="#FF0000">></font> m_lstDepth<font color="#FF0000">;</font>

    <font color="#006600">//Add items to the que</font>
    m_lstDepth.AddTail<font color="#FF0000">(</font> <font color="#6600FF">100</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstDepth.AddTail<font color="#FF0000">(</font>  <font color="#6600FF">85</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstDepth.AddTail<font color="#FF0000">(</font>  <font color="#6600FF">95</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstDepth.AddTail<font color="#FF0000">(</font>  <font color="#6600FF">90</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Process (show) the items in the list.</font>
    <font color="#0088FF">for</font><font color="#FF0000">(</font> POSITION pos <font color="#FF0000">=</font> m_lstDepth.GetHeadPosition<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font> pos <font color="#FF0000">!</font><font color="#FF0000">=</font> NULL<font color="#FF0000">;</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Dive depth is %4d\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> m_lstDepth.GetNext<font color="#FF0000">(</font> pos <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
</pre>

<a name="_UsingCMap"></a>
<h1>Using CMap.</h1>

<p>The CMap object is an simple collection, but unlike arrays and lists, which index and 
order the data they store, maps associate keys and values. To access a value stored in a 
map, specifying the values associated key. This is simular to a hash table.</p>

<pre>
<font color="#0088FF">#include</font> <font color="#FF0000"><</font>afxtempl.h<font color="#FF0000">></font>       <font color="#006600">// MFC suport for Collections</font>
...
    CMap<font color="#FF0000"><</font>CString<font color="#FF0000">,</font>LPCSTR<font color="#FF0000">,</font>CString<font color="#FF0000">,</font>CString<font color="#FF0000">&</font><font color="#FF0000">></font> m_mapAddress<font color="#FF0000">;</font>

    m_mapAddress<font color="#FF0000">[</font>_T<font color="#FF0000">(</font> <font color="#FF00FF">"10.1.1.102"</font> <font color="#FF0000">)</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"BILL"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_mapAddress<font color="#FF0000">[</font>_T<font color="#FF0000">(</font> <font color="#FF00FF">"10.1.1.108"</font> <font color="#FF0000">)</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"MAILSERVER"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_mapAddress<font color="#FF0000">[</font>_T<font color="#FF0000">(</font> <font color="#FF00FF">"10.1.1.112"</font> <font color="#FF0000">)</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"DevLaptop01"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_mapAddress<font color="#FF0000">[</font>_T<font color="#FF0000">(</font> <font color="#FF00FF">"10.1.1.10"</font> <font color="#FF0000">)</font><font color="#FF0000">]</font>  <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"PALEALE"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_mapAddress<font color="#FF0000">[</font>_T<font color="#FF0000">(</font> <font color="#FF00FF">"10.1.3.1"</font> <font color="#FF0000">)</font><font color="#FF0000">]</font>   <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"PTRAK"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>

    CString sMachine<font color="#FF0000">;</font>
    CString sUnknownIP <font color="#FF0000">=</font>  _T<font color="#FF0000">(</font> <font color="#FF00FF">"?0.?.?.112"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    sUnknownIP.Replace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"?"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"1"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_mapAddress.Lookup<font color="#FF0000">(</font> sUnknownIP<font color="#FF0000">,</font> sMachine <font color="#FF0000">)</font><font color="#FF0000">;</font>

    _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Machine at IP %s is %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> sUnknownIP<font color="#FF0000">,</font> sMachine <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<a name="_UsingPointers"></a>
<h1>Using pointers to objects.</h1>

<p>In all the previous examples the items in the list all supported the assigment 
<code>=</code> operator. This makes it possible to add and retrieve data from the
collection. Items that do not support the assignment operator can still be saved
to a collection but must be created and destroyed manualy. The objects must be 
dynamically allocated using the new operator, ie the "free store" or "heap"
this ensures they are not deleted once they go out of scope. Therefore when 
removed from the list they must be manually deleted. A destructor is often good 
place to perform this task. The following example shows a list of PERSON
structures that are created, displayed and deleted.</p>

<p>NOTE: Unlike other collections, pointers return the actual object rather than 
a copy, so changes made to the returned object are perminent.

<pre>
<font color="#0088FF">#include</font> <font color="#FF0000"><</font>afxtempl.h<font color="#FF0000">></font>                            <font color="#006600">// MFC suport for Collections</font>
...
<font color="#006600">//Person structure</font>
<font color="#0088FF">#define</font> LEN_CLOTH_SIZE    <font color="#FF0000">(</font><font color="#6600FF">5</font><font color="#FF0000">)</font>                    <font color="#006600">//Max cloth size length</font>
<font color="#0088FF">typedef</font> <font color="#0088FF">struct</font> _PERSON 
<font color="#FF0000">{</font>
    <font color="#0088FF">int</font>                nHeight<font color="#FF0000">;</font>                  <font color="#006600">//in cm</font>
    CString            sFullName<font color="#FF0000">;</font>                <font color="#006600">//Name</font>
    COleDateTime    tmBirthDate<font color="#FF0000">;</font>                 <font color="#006600">//Birthday</font>
    TCHAR            szShirt<font color="#FF0000">[</font>LEN_CLOTH_SIZE<font color="#FF0000">]</font><font color="#FF0000">;</font>    <font color="#006600">//Shirt size    </font>
 <font color="#FF0000">}</font> PERSON<font color="#FF0000">,</font> <font color="#FF0000">*</font>LPPERSON<font color="#FF0000">;</font>
 ...
   
    CList<font color="#FF0000"><</font> LPPERSON<font color="#FF0000">,</font> LPPERSON <font color="#FF0000">></font> m_lstPeople<font color="#FF0000">;</font>

    <font color="#006600">//Bilbos details</font>
    LPPERSON lpPerson <font color="#FF0000">=</font> <font color="#0088FF">new</font> PERSON<font color="#FF0000">;</font>
    lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>nHeight          <font color="#FF0000">=</font> <font color="#6600FF">95</font><font color="#FF0000">;</font>
    lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>sFullName        <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Bilbo Baggins"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    _tcscpy<font color="#FF0000">(</font> lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>szShirt<font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"XOS"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>tmBirthDate      <font color="#FF0000">=</font> COleDateTime<font color="#FF0000">(</font> <font color="#6600FF">1965</font><font color="#FF0000">,</font> <font color="#6600FF">6</font><font color="#FF0000">,</font> <font color="#6600FF">22</font><font color="#FF0000">,</font> <font color="#6600FF">3</font><font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstPeople.AddTail<font color="#FF0000">(</font> lpPerson <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Fredo details</font>
    lpPerson <font color="#FF0000">=</font> <font color="#0088FF">new</font> PERSON<font color="#FF0000">;</font>
    lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>nHeight          <font color="#FF0000">=</font> <font color="#6600FF">49</font><font color="#FF0000">;</font>
    lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>sFullName        <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Fredo Frog"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    _tcscpy<font color="#FF0000">(</font> lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>szShirt<font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"OS"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    lpPerson<font color="#FF0000">-</font><font color="#FF0000">></font>tmBirthDate      <font color="#FF0000">=</font> COleDateTime<font color="#FF0000">(</font> <font color="#6600FF">1965</font><font color="#FF0000">,</font> <font color="#6600FF">1</font><font color="#FF0000">,</font> <font color="#6600FF">5</font><font color="#FF0000">,</font> <font color="#6600FF">18</font><font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    m_lstPeople.AddTail<font color="#FF0000">(</font> lpPerson <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Display the People in the que</font>
    POSITION posPerson <font color="#FF0000">=</font> m_lstPeople.GetHeadPosition<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> posPerson <font color="#FF0000">!</font><font color="#FF0000">=</font> NULL <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        LPPERSON lpDisplayPerson <font color="#FF0000">=</font> m_lstPeople.GetNext<font color="#FF0000">(</font> posPerson <font color="#FF0000">)</font><font color="#FF0000">;</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Name .........%s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> lpDisplayPerson<font color="#FF0000">-</font><font color="#FF0000">></font>sFullName <font color="#FF0000">)</font><font color="#FF0000">;</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Height        %d\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> lpDisplayPerson<font color="#FF0000">-</font><font color="#FF0000">></font>nHeight  <font color="#FF0000">)</font><font color="#FF0000">;</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Shirt size    %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> lpDisplayPerson<font color="#FF0000">-</font><font color="#FF0000">></font>szShirt <font color="#FF0000">)</font><font color="#FF0000">;</font>
        _tprintf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Birthday      %s\n\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> lpDisplayPerson<font color="#FF0000">-</font><font color="#FF0000">></font>tmBirthDate.
            Format<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"%d/%b/%y %H:%M"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>

    <font color="#006600">//Free out the list</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> <font color="#FF0000">!</font>m_lstPeople.IsEmpty<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
       LPPERSON lpLostPerson <font color="#FF0000">=</font> m_lstPeople.RemoveHead<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
       <font color="#0088FF">delete</font> lpLostPerson<font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
</pre>



<!-- #include virtual="/Inc/NoteFooter.inc" --> 




