


<!-- #include virtual="/Inc/NoteHeader.inc" --> 

      <h4>Description.</h4>
      
      
      <p>If the handle or pointer to the CWnd is available it is a simple task 
      to post a message to that window with numbers or a pointer to some memory. See the
      article on "Getting pointers to Documents and Views" to see how to navigate
      the application.</p>
      
      
      <h4>Setting up the Post/Send message.</h4>

		A message must be defines higher than <code>WM_USER</code>. A good place
		for this is in the <code>StdAfx.h</code>
      
<pre>
<font color="#0088FF">#define</font> UNUSED_MEMORY           <font color="#FF0000">(</font><font color="#6600FF">0xcd</font><font color="#FF0000">)</font>              <font color="#006600">//Initialised memory   </font>
<font color="#0088FF">#define</font> FREED_MEMORY            <font color="#FF0000">(</font><font color="#6600FF">0xdd</font><font color="#FF0000">)</font>              <font color="#006600">//Deleted memory</font>
<font color="#0088FF">#define</font> ASSERT_USED<font color="#FF0000">(</font>x<font color="#FF0000">)</font>          ASSERT<font color="#FF0000">(</font> <font color="#FF0000">(</font>BYTE<font color="#FF0000">)</font>x<font color="#FF0000">[</font><font color="#6600FF">0</font><font color="#FF0000">]</font> <font color="#FF0000">!</font><font color="#FF0000">=</font> UNUSED_MEMORY <font color="#FF0000">)</font>
<font color="#0088FF">#define</font> ASSERT_NOT_DELETED<font color="#FF0000">(</font>x<font color="#FF0000">)</font>   ASSERT<font color="#FF0000">(</font> <font color="#FF0000">(</font>BYTE<font color="#FF0000">)</font>x<font color="#FF0000">[</font><font color="#6600FF">0</font><font color="#FF0000">]</font> <font color="#FF0000">!</font><font color="#FF0000">=</font> DELETED_MEMORY <font color="#FF0000">)</font>
   
<font color="#0088FF">#define</font> WM_MY_NUM_MESSAGE       <font color="#FF0000">(</font>WM_USER<font color="#FF0000">+</font><font color="#6600FF">23</font><font color="#FF0000">)</font>        <font color="#006600">//Number posting message</font>
<font color="#0088FF">#define</font> WM_MY_STRING_MESSAGE    <font color="#FF0000">(</font>WM_USER<font color="#FF0000">+</font><font color="#6600FF">24</font><font color="#FF0000">)</font>        <font color="#006600">//Memory posting message</font>
</pre>      

		Post or Send the the message to the other window as follows. Note Post
		will return immediately and be processed when the the system is idle
		to process messages. Send will be processed immediately. Any memory allocated 
		for the PostMessage should be freed when processed to ensure it is
		not deleted before it is used. For safety it is best to do this for SendMessage
		as well.


<pre>
    CWnd<font color="#FF0000">*</font> pWndOther <font color="#FF0000">=</font> AfxGetMainWnd<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>    <font color="#006600">//Get pointer to the window</font>
    ASSERT<font color="#FF0000">(</font> pWndOhter <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#006600">//Post some numbers and Wait for return</font>
    pWndOther<font color="#FF0000">-</font><font color="#FF0000">></font>SendMessage<font color="#FF0000">(</font> WM_MY_NUM_MESSAGE<font color="#FF0000">,</font> wSomeWord<font color="#FF0000">,</font> lSomeLong <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Post some Memory</font>
    LPCTSTR lpszName <font color="#FF0000">=</font> <font color="#0088FF">new</font> TCHAR<font color="#FF0000">[</font>MY_STR_LEN<font color="#FF0000">+</font><font color="#6600FF">1</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> lpszName <font color="#FF0000">!</font><font color="#FF0000">=</font> NULL <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        strncpy<font color="#FF0000">(</font> lpszName<font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Some name data"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> MY_STR_LEN <font color="#FF0000">)</font><font color="#FF0000">;</font>
        lpszName<font color="#FF0000">[</font>MY_STR_LEN<font color="#FF0000">-</font><font color="#6600FF">1</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> NULL<font color="#FF0000">;</font>
        pWndOther<font color="#FF0000">-</font><font color="#FF0000">></font>PostMessage<font color="#FF0000">(</font> WM_MY_STRING_MESSAGE<font color="#FF0000">,</font> wSomeWord<font color="#FF0000">,</font> lpszName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">else</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//TODO : Process no memory error</font>
    <font color="#FF0000">}</font>
</pre>  

      <h4>Processing the Message.</h4>
      
      Notification of the message will be come through the message handler
      the functions should be defined in the header/definition.
            
<pre>
    <font color="#006600">//}}AFX_MSG</font>
    afx_msg LONG OnNummber<font color="#FF0000">(</font> WPARAM wSomeWord<font color="#FF0000">,</font> LPARAM lSomeLong <font color="#FF0000">)</font><font color="#FF0000">;</font>
    afx_msg LONG OnString<font color="#FF0000">(</font> WPARAM wSomeWord<font color="#FF0000">,</font> LPARAM lName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    DECLARE_MESSAGE_MAP<font color="#FF0000">(</font><font color="#FF0000">)</font>
</pre>

		In the implementation file add to the message map as follows.
            
<pre>
    <font color="#006600">//}}AFX_MSG_MAP</font>
    ON_MESSAGE<font color="#FF0000">(</font>WM_MY_NUM_MESSAGE<font color="#FF0000">,</font> OnNumber<font color="#FF0000">)</font>
    ON_MESSAGE<font color="#FF0000">(</font>WM_MY_STRING_MESSAGE<font color="#FF0000">,</font> OnString<font color="#FF0000">)</font>
END_MESSAGE_MAP<font color="#FF0000">(</font><font color="#FF0000">)</font>
</pre>

		Now process the message.
            
<pre>
<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      Do something with the numbers</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      wSomeWord   Blah blah ....</font>
<font color="#006600">//      lSomeLong   Blah blah ....</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//      no relevant for PostMessage but used for SendMessage</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    26-6-2000, 14:59:17 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
LONG CMainFrame<font color="#FF0000">:</font><font color="#FF0000">:</font>OnNumber<font color="#FF0000">(</font> WPARAM wSomeWord<font color="#FF0000">,</font> LPARAM lSomeLong <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CMainFrame::OnNumber( %d, %ld )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> wSomeWord<font color="#FF0000">,</font> lSomeLong <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">return</font><font color="#FF0000">(</font> wSomeWord <font color="#FF0000">+</font> lSomeLong <font color="#FF0000">)</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>



<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      Do something with the string</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      wSomeWord   Blah blah ....</font>
<font color="#006600">//      lName       Blah blah ....</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//      no relevant for PostMessage but used for SendMessage</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    26-6-2000, 14:59:17 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
LONG CMainFrame<font color="#FF0000">:</font><font color="#FF0000">:</font>OnString<font color="#FF0000">(</font> WPARAM wSomeWord<font color="#FF0000">,</font> LPARAM lName <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CMainFrame::OnString( %d, %ld )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> wSomeWord<font color="#FF0000">,</font> lName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    LPCTSTR lpszName <font color="#FF0000">=</font> <font color="#FF0000">(</font>LPCTSTR<font color="#FF0000">)</font>lName<font color="#FF0000">;</font>           <font color="#006600">//Case MUST be appropiate</font>
    ASSERT<font color="#FF0000">(</font> lpszName <font color="#FF0000">!</font><font color="#FF0000">=</font> NULL <font color="#FF0000">)</font><font color="#FF0000">;</font>
    ASSERT_USED<font color="#FF0000">(</font> lpszName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    ASSERT_NOT_DELETED<font color="#FF0000">(</font> lpszName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    SetWindowTitle<font color="#FF0000">(</font> lpszName  <font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#0088FF">delete</font> <font color="#FF0000">[</font><font color="#FF0000">]</font> lpszName<font color="#FF0000">;</font>
    
    <font color="#006600">//Return something useful only if the SendMessage is used</font>
    <font color="#0088FF">return</font><font color="#FF0000">(</font> wSomeWord <font color="#FF0000">+</font> <font color="#6600FF">1</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>


<!-- #include virtual="/Inc/NoteFooter.inc" --> 




