


<!-- #include virtual="/Inc/NoteHeader.inc" --> 


      <h4>Description.</h4>
      
      <p>The registry is a good place to save configuration information about
      you application. Functions to retrieve this information are presented in this section.
      Remember avoid writing large amount of data to register.
      
      <h4>Simple "HKEY_CURRENT_USER\Software" key.</h4>
      
      When you create a simple MFC application the wizard the following line to 
      the <code>CZzzzz::InitInstance()</code> function.
      
<pre>
    <font color="#006600">// Change the registry key under which our settings are stored.</font>
    <font color="#006600">// TODO: You should modify this string to be something appropriate</font>
    <font color="#006600">// such as the name of your company or organization.</font>
    SetRegistryKey<font color="#FF0000">(</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"Local AppWizard-Generated Applications"</font><font color="#FF0000">)</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>
      
     <P>By changing the string you will be able to read and write data
     about your application. It will appear in the registery in a key such
     as "HKEY_CURRENT_USER\Software\MyCompany\MyAppName".
     
     <p>To write a string or integer to the registry use the following

<pre>
    AfxGetApp<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">-</font><font color="#FF0000">></font>WriteProfileString<font color="#FF0000">(</font> 
        _T<font color="#FF0000">(</font><font color="#FF00FF">"UserInfo"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Name"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Bill"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    AfxGetApp<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">-</font><font color="#FF0000">></font>WriteProfileInt<font color="#FF0000">(</font> 
        _T<font color="#FF0000">(</font><font color="#FF00FF">"UserInfo"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"DefaultFontSize"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> <font color="#6600FF">12</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>     

		This information will be stored in the registry and persistent for this user.
		However if another user logs on the "HKEY_CURRENT_USER" will be different,
      ie the data in this section is user specific.

		<p> To read the data in the registry for this user / application use;
<pre>
    CString sUserName <font color="#FF0000">=</font> AfxGetApp<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">-</font><font color="#FF0000">></font>GetProfileString<font color="#FF0000">(</font> 
        _T<font color="#FF0000">(</font><font color="#FF00FF">"UserInfo"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Name"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
        _T<font color="#FF0000">(</font><font color="#FF00FF">"Unknown"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    UINT nFont <font color="#FF0000">=</font> AfxGetApp<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">-</font><font color="#FF0000">></font>ReadProfileInt<font color="#FF0000">(</font> 
        _T<font color="#FF0000">(</font><font color="#FF00FF">"UserInfo"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"DefaultFontSize"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
        <font color="#6600FF">8</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>     

     <p>In both cases id the registry key does not exist the default value is returned.
     
Note:
<UL type=circle>
	<LI>Strings are limited to _MAX_PATH in length.</LI>
	<LI>This member function is not case sensitive, so the strings in the 
		<code>lpszSection</code> and <code>lpszEntry</code> parameters may differ in case.</LI>
	<LI>These commands are limited to the "HKEY_CURRENT_USER\Software\MyCompany\MyAppName" key only and
	are not persistent across different profiles.</LI>
	<LI>These function should not be called too often within an application as
	they do take significant time to complete.</LI>
	<LI>Try to discourage support engineers from modifying the registery using Regedit (by hand) by
	creating all missing keys when the application starts and populating them with
	default values.</LI>
</UL>

      <h4>Advanced Registry access routines. (Read and Write)</h4>

		It is often advantageous to be able to read and write to other keys in the registery
		some common reasons are.

<UL type=circle>
	<LI>To make data persistant between user profiles.</LI>
	<LI>Read regietry settings of other programs.</LI>
</UL>

	<p>This first example works in a simular way to the above functions 
	but stores data that is persistant across user profiles.

<p>Header file.	
<pre>
<font color="#006600">//////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//</font>
<font color="#006600">// EASYREG.h: interface for the CEasyReg class.</font>
<font color="#006600">//</font>
<font color="#006600">//////////////////////////////////////////////////////////////////////</font>

<font color="#0088FF">#if</font> <font color="#FF0000">!</font><font color="#0088FF">defined</font><font color="#FF0000">(</font>AFX_EASYREG_H__4CEB51C3_8190_42b0_9D91_5C__INCLUDED_<font color="#FF0000">)</font>
<font color="#0088FF">#define</font> AFX_EASYREG_H__4CEB51C3_8190_42b0_9D91_5C__INCLUDED_

<font color="#0088FF">#if</font> _MSC_VER <font color="#FF0000">></font> <font color="#6600FF">1000</font>
<font color="#0088FF">#pragma</font> <font color="#0088FF">once</font>
<font color="#0088FF">#endif</font> <font color="#006600">// _MSC_VER > 1000</font>

<font color="#0088FF">#include</font> <font color="#FF0000"><</font>atlbase.h<font color="#FF0000">></font>                        <font color="#006600">//ATL support for CRegKey</font>

<font color="#006600">//////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//CLASS DEFINITION:</font>
<font color="#006600">// CEasyReg</font>
<font color="#0088FF">class</font> CEasyReg <font color="#FF0000">:</font> <font color="#0088FF">public</font> CRegKey 
<font color="#FF0000">{</font>
<font color="#006600">//Operators</font>
<font color="#0088FF">public</font><font color="#FF0000">:</font>
    CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font>CEasyReg<font color="#FF0000">(</font> CString sSupplier <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">""</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">virtual</font> <font color="#FF0000">~</font>CEasyReg<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>

    DWORD   GetDW<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font>  DWORD dwDefault <font color="#FF0000">=</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    CString GetStr<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> LPCSTR lpszDefault <font color="#FF0000">=</font> NULL <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">bool</font>    SetDW<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> DWORD dwVal <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">bool</font>    SetStr<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> LPCSTR lpszValue <font color="#FF0000">)</font><font color="#FF0000">;</font>

<font color="#006600">//Attributes</font>
<font color="#0088FF">public</font><font color="#FF0000">:</font>

<font color="#006600">//Operators</font>
<font color="#0088FF">private</font><font color="#FF0000">:</font>

<font color="#006600">//Attributes</font>
<font color="#0088FF">private</font><font color="#FF0000">:</font>
<font color="#FF0000">}</font><font color="#FF0000">;</font>

<font color="#0088FF">#endif</font> <font color="#006600">// !defined(AFX_EASYREG_H__4CEB51C3_8190_42b0_9D91_5C__INCLUDED_)</font>
</pre>
<p>Implementation file
<pre>
<font color="#006600">//////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//</font>
<font color="#006600">// EasyReg.cpp: implementation of the CEasyReg class.</font>
<font color="#006600">//</font>
<font color="#006600">//////////////////////////////////////////////////////////////////////</font>

<font color="#0088FF">#include</font> <font color="#FF00FF">"stdafx.h"</font>
<font color="#0088FF">#include</font> <font color="#FF00FF">"EasyReg.h"</font>                            

<font color="#0088FF">#ifdef</font> _DEBUG
<font color="#0088FF">#undef</font> THIS_FILE
<font color="#0088FF">static</font> <font color="#0088FF">char</font> THIS_FILE<font color="#FF0000">[</font><font color="#FF0000">]</font><font color="#FF0000">=</font>__FILE__<font color="#FF0000">;</font>
<font color="#0088FF">#define</font> <font color="#0088FF">new</font> DEBUG_NEW
<font color="#0088FF">#endif</font>

<font color="#006600">///////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//    Open the MyCompany directory on entry</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    10-7-1999  9:34:08</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//    sSupplier    Suppliers name OR "MyCompany" for Empty()</font>
<font color="#006600">//    bErrorDisp   True is Errors are to be displayed.</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//    </font>
CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font>CEasyReg<font color="#FF0000">(</font> CString sSupplier <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    <font color="#006600">//</font>
    <font color="#006600">//Open the Registery key</font>
    <font color="#006600">//</font>
    CString sKeyName <font color="#FF0000">=</font> sSupplier.IsEmpty<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">?</font> 
                       _T<font color="#FF0000">(</font><font color="#FF00FF">"SOFTWARE\\MyCompany"</font><font color="#FF0000">)</font> <font color="#FF0000">:</font> 
                       sSupplier<font color="#FF0000">;</font>
    Create<font color="#FF0000">(</font> HKEY_LOCAL_MACHINE<font color="#FF0000">,</font> sKeyName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    Close<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    
    <font color="#0088FF">if</font><font color="#FF0000">(</font> sSupplier.IsEmpty<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        sKeyName <font color="#FF0000">+</font><font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"\\");</font>
        sKeyName <font color="#FF0000">+</font><font color="#FF0000">=</font> AfxGetAppName<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    <font color="#006600">//Now open the actual key</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> Create<font color="#FF0000">(</font> HKEY_LOCAL_MACHINE<font color="#FF0000">,</font> sKeyName <font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        CString sError <font color="#FF0000">=</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"Unable to access Registery\n"</font><font color="#FF0000">)</font>\
                        _T<font color="#FF0000">(</font><font color="#FF00FF">"HKEY_LOCAL_MACHINE\\") + </font>
                            sKeyName <font color="#FF0000">+</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"\n"</font><font color="#FF0000">)</font>\
                        _T<font color="#FF0000">(</font><font color="#FF00FF">"Will not be able to setup system."</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        AfxMessageBox<font color="#FF0000">(</font>    sError<font color="#FF0000">,</font> MB_ICONSTOP <font color="#FF0000">|</font> MB_SYSTEMMODAL <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>

<font color="#006600">///////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//    Clean up the House on the way home</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    10-7-1999  9:33:52</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//    </font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//    </font>
CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font><font color="#FF0000">~</font>CEasyReg<font color="#FF0000">(</font><font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    Close<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>


<font color="#006600">///////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//    Extract data from the System. Also add the Key if it is not their</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    11-7-1999  11:31:00</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//    lpszField    Key field name</font>
<font color="#006600">//    dwDefault    Default value</font>
<font color="#006600">//    lpszDefault   ..</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//    read value.</font>
DWORD CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font>GetDW<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> DWORD dwDefault <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    DWORD dwRet<font color="#FF0000">;</font>                                    <font color="#006600">//Returned value</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> QueryValue<font color="#FF0000">(</font>dwRet <font color="#FF0000">,</font> lpszField <font color="#FF0000">)</font> <font color="#FF0000">!</font><font color="#FF0000">=</font> ERROR_SUCCESS <font color="#FF0000">)</font>
        dwRet <font color="#FF0000">=</font> dwDefault<font color="#FF0000">;</font>
    <font color="#006600">//Optionally set the read value to create the key for next time</font>
    SetValue<font color="#FF0000">(</font> dwRet<font color="#FF0000">,</font> lpszField <font color="#FF0000">)</font><font color="#FF0000">;</font>    
    <font color="#0088FF">return</font> dwRet<font color="#FF0000">;</font>
<font color="#FF0000">}</font>
CString CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font>GetStr<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> LPCSTR lpszDefault <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    CString sRet<font color="#FF0000">;</font>                                   <font color="#006600">//Returned value</font>
    TCHAR szBuff<font color="#FF0000">[</font><font color="#6600FF">1025</font><font color="#FF0000">]</font><font color="#FF0000">;</font>                             <font color="#006600">//Read buffer</font>
    DWORD dwSize <font color="#FF0000">=</font> <font color="#6600FF">1024</font><font color="#FF0000">;</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> QueryValue<font color="#FF0000">(</font> szBuff<font color="#FF0000">,</font> lpszField<font color="#FF0000">,</font> <font color="#FF0000">&</font>dwSize <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> ERROR_SUCCESS <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        szBuff<font color="#FF0000">[</font>dwSize<font color="#FF0000">]</font> <font color="#FF0000">=</font> NULL<font color="#FF0000">;</font>
        sRet <font color="#FF0000">=</font> szBuff<font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">else</font>
    <font color="#FF0000">{</font>
        sRet <font color="#FF0000">=</font> lpszDefault <font color="#FF0000">?</font> lpszDefault <font color="#FF0000">:</font> _T<font color="#FF0000">(</font><font color="#FF00FF">""</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    <font color="#006600">//Optionally set the read value to create the key for next time</font>
    SetValue<font color="#FF0000">(</font> sRet<font color="#FF0000">,</font> lpszField <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">return</font> sRet<font color="#FF0000">;</font>
<font color="#FF0000">}</font>



<font color="#006600">///////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//    Save the Data to the Registery</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    11-7-1999  11:31:00</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//    lpszField   Key field name</font>
<font color="#006600">//    dwVal       Default value</font>
<font color="#006600">//    lpszData    ..</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//    read value.</font>
<font color="#0088FF">bool</font> CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font>SetDW<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> DWORD dwVal <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> SetValue<font color="#FF0000">(</font> dwVal<font color="#FF0000">,</font> lpszField <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> ERROR_SUCCESS <font color="#FF0000">)</font>
        <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
    CString sError <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Unable to access Registery\n"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>lpszField<font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"\n"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"To save value."</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    AfxMessageBox<font color="#FF0000">(</font>    sError<font color="#FF0000">,</font> MB_ICONSTOP <font color="#FF0000">|</font> MB_SYSTEMMODAL <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
<font color="#0088FF">bool</font> CEasyReg<font color="#FF0000">:</font><font color="#FF0000">:</font>SetStr<font color="#FF0000">(</font> LPCSTR lpszField<font color="#FF0000">,</font> LPCSTR lpszValue <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> SetValue<font color="#FF0000">(</font> lpszValue<font color="#FF0000">,</font> lpszField <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> ERROR_SUCCESS <font color="#FF0000">)</font>
        <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
    CString sError <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Unable to access Registery\n"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>lpszField<font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"\n"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>_T<font color="#FF0000">(</font><font color="#FF00FF">"To save value.\n"</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
            sError <font color="#FF0000">+</font><font color="#FF0000">=</font>lpszValue<font color="#FF0000">;</font>
    AfxMessageBox<font color="#FF0000">(</font>    sError<font color="#FF0000">,</font> MB_ICONSTOP <font color="#FF0000">|</font> MB_SYSTEMMODAL <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>

      <h4>Advanced Registry access routines. (Read only)</h4>


<p>Alternatively to read a single entry use the following function.

<pre>
<font color="#006600">///////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//    Extracts the Data from the provided registery key</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//    13-10-1998  11:05:05</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//    KeyRoot         HKEY_LOCAL_MACHINE, ...</font>
<font color="#006600">//    szSubKey        ie, _T("Software\\Microsoft\\Internet Explorer")</font>
<font color="#006600">//    lpValueName     _T("") to read "(Default)"</font>
<font color="#006600">//    pData           Data to recieve</font>
<font color="#006600">//    pdwSize         Size of data read (0 for errors)</font>
<font color="#006600">//    dwExpectType    Type of Data expected, ie REG_SZ.</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//    true if all goes well.</font>
<font color="#0088FF">bool</font> GetRegData<font color="#FF0000">(</font> HKEY KeyRoot<font color="#FF0000">,</font> LPCTSTR szSubKey<font color="#FF0000">,</font> LPCTSTR lpValueName<font color="#FF0000">,</font> 
                <font color="#0088FF">void</font> <font color="#FF0000">*</font><font color="#0088FF">const</font> pData<font color="#FF0000">,</font> DWORD <font color="#FF0000">*</font><font color="#0088FF">const</font> pdwSize<font color="#FF0000">,</font> DWORD dwExpectType <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"GetRegData( %x, %s, %s, %p, %x, %x )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> KeyRoot<font color="#FF0000">,</font> szSubKey<font color="#FF0000">,</font> 
        lpValueName<font color="#FF0000">,</font> pData<font color="#FF0000">,</font> <font color="#FF0000">*</font>pdwSize<font color="#FF0000">,</font> dwExpectType <font color="#FF0000">)</font><font color="#FF0000">;</font>
    DWORD    dwType<font color="#FF0000">;</font>                          <font color="#006600">//Returned data type</font>
    DWORD   rc<font color="#FF0000">;</font>                               <font color="#006600">//Responce from the Registery calls</font>
    HKEY    hKeySubKey <font color="#FF0000">=</font> NULL<font color="#FF0000">;</font>                <font color="#006600">//Opend Key</font>

    <font color="#006600">//</font>
    <font color="#006600">//Open the Key</font>
    <font color="#006600">//</font>
    rc <font color="#FF0000">=</font> RegOpenKeyEx<font color="#FF0000">(</font> HKEY_LOCAL_MACHINE<font color="#FF0000">,</font> 
                       szSubKey<font color="#FF0000">,</font> 
                       <font color="#6600FF">0</font><font color="#FF0000">,</font> 
                       KEY_QUERY_VALUE<font color="#FF0000">,</font> 
                       <font color="#FF0000">&</font>hKeySubKey <font color="#FF0000">)</font><font color="#FF0000">;</font> 
    <font color="#006600">//Display the Error and Return</font>
    <font color="#0088FF">if</font> <font color="#FF0000">(</font>rc <font color="#FF0000">!</font><font color="#FF0000">=</font> ERROR_SUCCESS<font color="#FF0000">)</font> 
    <font color="#FF0000">{</font> 
        <font color="#FF0000">*</font>pdwSize <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
        <font color="#0088FF">const</font> DWORD dwMessSize <font color="#FF0000">=</font> <font color="#6600FF">1024</font><font color="#FF0000">;</font>
        TCHAR szBuff<font color="#FF0000">[</font>dwMessSize<font color="#FF0000">]</font><font color="#FF0000">;</font> 
        FormatMessage<font color="#FF0000">(</font> FORMAT_MESSAGE_FROM_SYSTEM<font color="#FF0000">,</font> NULL<font color="#FF0000">,</font> rc<font color="#FF0000">,</font> NULL<font color="#FF0000">,</font> 
            szBuff<font color="#FF0000">,</font> dwMessSize<font color="#FF0000">,</font> NULL <font color="#FF0000">)</font><font color="#FF0000">;</font>
        OpFailTrace<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"OPENING : %s"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szBuff <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font> 
    <font color="#FF0000">}</font> 

    <font color="#006600">//</font>
    <font color="#006600">//Open the Sub Key to Get the Data</font>
    <font color="#006600">//</font>
     rc <font color="#FF0000">=</font> RegQueryValueEx<font color="#FF0000">(</font>    hKeySubKey<font color="#FF0000">,</font>
                            lpValueName<font color="#FF0000">,</font> <font color="#6600FF">0</font><font color="#FF0000">,</font> <font color="#FF0000">&</font>dwType<font color="#FF0000">,</font>
                            <font color="#FF0000">(</font>LPBYTE<font color="#FF0000">)</font>pData<font color="#FF0000">,</font> pdwSize <font color="#FF0000">)</font><font color="#FF0000">;</font>

    RegCloseKey<font color="#FF0000">(</font> hKeySubKey <font color="#FF0000">)</font><font color="#FF0000">;</font>                    <font color="#006600">//Close up shop.</font>

    <font color="#006600">//Display the Error and Return</font>
    <font color="#0088FF">if</font> <font color="#FF0000">(</font>rc <font color="#FF0000">!</font><font color="#FF0000">=</font> ERROR_SUCCESS<font color="#FF0000">)</font> 
    <font color="#FF0000">{</font> 
        <font color="#FF0000">*</font>pdwSize <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
        <font color="#0088FF">const</font> DWORD dwMessSize <font color="#FF0000">=</font> <font color="#6600FF">1024</font><font color="#FF0000">;</font>
        TCHAR szBuff<font color="#FF0000">[</font>dwMessSize<font color="#FF0000">]</font><font color="#FF0000">;</font> 
        FormatMessage<font color="#FF0000">(</font> FORMAT_MESSAGE_FROM_SYSTEM<font color="#FF0000">,</font> NULL<font color="#FF0000">,</font> rc<font color="#FF0000">,</font> NULL<font color="#FF0000">,</font> szBuff<font color="#FF0000">,</font> 
            dwMessSize<font color="#FF0000">,</font> NULL <font color="#FF0000">)</font><font color="#FF0000">;</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"ERROR READING : %n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szBuff <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font> 
    <font color="#FF0000">}</font> 

    <font color="#006600">//Display error for Data type</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> dwType <font color="#FF0000">!</font><font color="#FF0000">=</font> dwExpectType <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"ERROR Wrong data type : Recieved %d, Expected %d\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
            dwType<font color="#FF0000">,</font> dwExpectType <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font> 
    <font color="#FF0000">}</font>

    <font color="#006600">//All is well so return</font>
    <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




