


<!-- #include virtual="/Inc/NoteHeader.inc" --> 


      <h4>Description.</h4>
      
      
      <p>Accessing data in files is a key part of software development. Here are
      some simple samples of file I/O that include error trapping.&nbsp;</p>
      
      
      <h4>Read a file into a CString.</h4>
      
<pre>
<font color="#0088FF">bool</font> LoadFile<font color="#FF0000">(</font> CString sFileName<font color="#FF0000">,</font> CString <font color="#FF0000">*</font>psLoad <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"LoadFile(%s,0x%p)\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> sFileName<font color="#FF0000">,</font> psLoad <font color="#FF0000">)</font><font color="#FF0000">;</font>
    ASSERT<font color="#FF0000">(</font> psLoad <font color="#FF0000">)</font><font color="#FF0000">;</font>
    TRY
    <font color="#FF0000">{</font>
        CFile fileIn<font color="#FF0000">(</font> sFileName<font color="#FF0000">,</font> CFile<font color="#FF0000">:</font><font color="#FF0000">:</font>modeRead <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">int</font> nLen <font color="#FF0000">=</font> fileIn.GetLength<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> nLen <font color="#FF0000">></font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            fileIn.Read<font color="#FF0000">(</font> psLoad<font color="#FF0000">-</font><font color="#FF0000">></font>GetBuffer<font color="#FF0000">(</font> nLen <font color="#FF0000">)</font><font color="#FF0000">,</font> nLen <font color="#FF0000">)</font><font color="#FF0000">;</font>
            psLoad<font color="#FF0000">-</font><font color="#FF0000">></font>ReleaseBuffer<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        fileIn.Close<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    CATCH<font color="#FF0000">(</font>CFileException<font color="#FF0000">,</font> pEx<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Show error message</font>
        CString sErrorMess<font color="#FF0000">;</font>
        TCHAR   szCause<font color="#FF0000">[</font><font color="#6600FF">255</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
        pEx<font color="#FF0000">-</font><font color="#FF0000">></font>GetErrorMessage<font color="#FF0000">(</font>szCause<font color="#FF0000">,</font> <font color="#6600FF">255</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        sErrorMess.Format<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Error %s\n Reading %s"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
            szCause<font color="#FF0000">,</font> 
            pEx<font color="#FF0000">-</font><font color="#FF0000">></font>m_strFileName <font color="#FF0000">)</font><font color="#FF0000">;</font>
        AfxMessageBox<font color="#FF0000">(</font> sErrorMess <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    AND_CATCH<font color="#FF0000">(</font>CMemoryException<font color="#FF0000">,</font> pEx<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Memory execption are often associated with </font>
        <font color="#006600">//CString objects. Normally, an application should </font>
        <font color="#006600">// do everything it possibly can to</font>
        <font color="#006600">// clean up properly and _not_ call AfxAbort().</font>
        AfxAbort<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    END_CATCH<font color="#FF0000">;</font>
    <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>      

      <h4>Save a CString to a file.</h4>
      
<pre>
<font color="#0088FF">bool</font> SaveFile<font color="#FF0000">(</font> CString sFileName<font color="#FF0000">,</font> CString sSave <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"SaveFile(%s,sSave)\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> sFileName <font color="#FF0000">)</font><font color="#FF0000">;</font>
    TRY
    <font color="#FF0000">{</font>
        CFile fileOut<font color="#FF0000">(</font> sFileName<font color="#FF0000">,</font> 
            CFile<font color="#FF0000">:</font><font color="#FF0000">:</font>modeCreate <font color="#FF0000">|</font> CFile<font color="#FF0000">:</font><font color="#FF0000">:</font>modeWrite <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">int</font> nLen <font color="#FF0000">=</font> sSave.GetLength<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> nLen <font color="#FF0000">></font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>
            fileOut.Write<font color="#FF0000">(</font> sSave.GetBuffer<font color="#FF0000">(</font> nLen <font color="#FF0000">)</font><font color="#FF0000">,</font> nLen <font color="#FF0000">)</font><font color="#FF0000">;</font>
            sSave.ReleaseBuffer<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        fileOut.Close<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    CATCH<font color="#FF0000">(</font>CFileException<font color="#FF0000">,</font> pEx<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Show error message</font>
        CString sErrorMess<font color="#FF0000">;</font>
        TCHAR   szCause<font color="#FF0000">[</font><font color="#6600FF">255</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
        pEx<font color="#FF0000">-</font><font color="#FF0000">></font>GetErrorMessage<font color="#FF0000">(</font>szCause<font color="#FF0000">,</font> <font color="#6600FF">255</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        sErrorMess.Format<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Error %s\n Writing %s"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
            szCause<font color="#FF0000">,</font> 
            pEx<font color="#FF0000">-</font><font color="#FF0000">></font>m_strFileName <font color="#FF0000">)</font><font color="#FF0000">;</font>
        AfxMessageBox<font color="#FF0000">(</font> sErrorMess <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    AND_CATCH<font color="#FF0000">(</font>CMemoryException<font color="#FF0000">,</font> pEx<font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//Memory execption are often associated with </font>
        <font color="#006600">//CString objects. Normally, an application should </font>
        <font color="#006600">// do everything it possibly can to</font>
        <font color="#006600">// clean up properly and _not_ call AfxAbort().</font>
        AfxAbort<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    END_CATCH<font color="#FF0000">;</font>
    <font color="#0088FF">return</font> <font color="#0088FF">true</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




