


<!-- #include virtual="/Inc/NoteHeader.inc" --> 


      <h4>Description.</h4>
      
      
      <p>Using <code>LoadString()</code> is convenient but does not suit large documents which
      can more easily be edited in notepad type editors and kept in separate files to enable
      better source control.</p>
      
      
      <h4>Solution.</h4>
      
      
      <ul>
        <li>Put the Text file in the <code>project\res</code> directory.</li>
        <li>Add the Text file to VSS.</li>
        <li>Add the following line to <code>MyApplication.rc2</code> (In this example the
          text file is called <code>JohnsNotes.txt</code>.</li>
      </ul>
      
      
<pre>
    IDTXT_JOHNS_NOTES TEXT res\JohnsNotes.txt
</pre>


    <ul>
        <li>Where the text is to be loaded place the following code. Note in
          this example the text is placed into an exit box called <code>IDC_NOTES</code>.</li>
     </ul>
      
<pre>
    <font color="#006600">//Insert the Licence agreement  </font>
    HINSTANCE hAppRes <font color="#FF0000">=</font> AfxGetResourceHandle<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font> 
    HRSRC hResTemp <font color="#FF0000">=</font> <font color="#FF0000">:</font><font color="#FF0000">:</font>FindResource<font color="#FF0000">(</font> hAppRes<font color="#FF0000">,</font> <font color="#FF00FF">"IDTXT_JOHNS_NOTES"</font><font color="#FF0000">,</font> <font color="#FF00FF">"TEXT"</font> <font color="#FF0000">)</font><font color="#FF0000">;</font> 
    HANDLE hTextResource <font color="#FF0000">=</font> <font color="#FF0000">:</font><font color="#FF0000">:</font>LoadResource<font color="#FF0000">(</font> hAppRes<font color="#FF0000">,</font> hResTemp <font color="#FF0000">)</font><font color="#FF0000">;</font> 
    <font color="#0088FF">if</font><font color="#FF0000">(</font> hTextResource <font color="#FF0000">)</font> 
    <font color="#FF0000">{</font> 
        <font color="#006600">//Points to  ocked data in memory</font>
        LPSTR lpResData <font color="#FF0000">=</font> <font color="#FF0000">(</font>LPSTR<font color="#FF0000">)</font><font color="#FF0000">:</font><font color="#FF0000">:</font>LockResource<font color="#FF0000">(</font> hTextResource <font color="#FF0000">)</font><font color="#FF0000">;</font> 
        SetDlgItemText<font color="#FF0000">(</font> IDC_THE_NOTES<font color="#FF0000">,</font> lpResData <font color="#FF0000">)</font><font color="#FF0000">;</font> 
        <font color="#FF0000">:</font><font color="#FF0000">:</font>FreeResource<font color="#FF0000">(</font> hTextResource <font color="#FF0000">)</font><font color="#FF0000">;</font> 
    <font color="#FF0000">}</font>  
</pre>
       
      
<!-- #include virtual="/Inc/NoteFooter.inc" --> 




