namespace Net
{
    using System;
	using System.Web;
    using System.Web.SessionState;
	using System.Data.ADO;							//Database
	using System.Globalization;						//Date

    /// <summary>
    ///    Class to read and write member details.
    /// </summary>
    public class MemberDetails
    {
		//Attributes
		private HttpSessionState m_Session;
		private string m_sMemberID	= "";			//Read must me called to set this
		private string m_sName		= "";
		private string m_sEmail		= "";
		private string m_sState		= "";
		private string m_sCountry	= "";

		//Property readers ( makes property read only )
		public string Name		{ get { return m_sName;  }  }
		public string EMail		{ get { return m_sEmail;  }  }
		public string State		{ get { return m_sState;  }  }
		public string Country	{ get { return m_sCountry;  }  }

		/// <summary>
		/// Constructor and save a pointer to the session object.
		/// </summary>
		/// <param name="Session"> Session object. </param>
        public MemberDetails( HttpSessionState Session )
        { 
			m_Session = Session;
			Session["Member"] = this;
        }

		/// <summary>
		/// Read the member details if they exist and populate them into the 
		/// Session state variables.
		/// </summary>
		/// <param name="Request">Request object.</param>
		public void Read( HttpRequest Request, HttpResponse Response )
		{  
			//Get the Members OLD Cookie to identify then
			HttpCookie objHttpCookie = Request.Cookies["MemberID"];
			int nVisitCount = 0;
			DateTime dtNow = DateTime.Now;
			string sNow = dtNow.Format( "G", DateTimeFormatInfo.CurrentInfo );
			m_sMemberID = "";

			if( objHttpCookie != null && objHttpCookie.Values.All.Length > 0 )
			{
				m_sMemberID = objHttpCookie.Values.All[0];
			}

			//Create a new session ID and log create a new database entry
			if( m_sMemberID == "" )
			{
				m_sMemberID = m_Session.SessionID;
				HttpCookie ckMember = new HttpCookie( "MemberID", m_sMemberID );
				ckMember.Expires = new DateTime( 2010, 12, 30 ); 
				Response.Cookies.Add( ckMember );
			}
			m_Session[ "MemberID" ] = m_sMemberID;

			//Get the visitors existing details (if available)
			string sSqlCmd = "SELECT * FROM Member WHERE MemberID = '"+ m_sMemberID +"'";
			try
			{
				//Open the Member database
				ADODataReader dr;
				ADOConnection conn = new ADOConnection(Global.DB_CONN_STRING);
				conn.Open();
				ADOCommand cmd = new ADOCommand( sSqlCmd, conn );
				cmd.Execute( out dr);
				if( dr.Read() )
				{
					//Read existing
					object objDb;
					objDb = dr["Name"];			if( objDb != null )	m_sName		= objDb.ToString();
					objDb = dr["EMail"];		if( objDb != null )	m_sEmail	= objDb.ToString();
					objDb = dr["State"];		if( objDb != null )	m_sState	= objDb.ToString();
					objDb = dr["Country"];		if( objDb != null )	m_sCountry	= objDb.ToString();
					objDb = dr["VisitCount"];	if( objDb != null )	nVisitCount	= (int)objDb;

					//Build SQL update string
					sSqlCmd = "UPDATE Member " +
						" SET VisitCount" + " = "  + (nVisitCount+1) +
						" ,   LastVisit"  + " = '" + sNow + "' " +
						" WHERE MemberID = '"+ m_sMemberID +"'";;			
				}
				else
				{
					//Build the insert string
					sSqlCmd = "INSERT INTO Member (MemberID, Since, VisitCount) " +
   						"VALUES(" +
						"'" + m_sMemberID + "', " +
						"'" + sNow + "', " +
						"1 );";
				}

				//Update the Member databaes
				dr.Close();
				cmd = new ADOCommand( sSqlCmd, conn );
				cmd.ExecuteNonQuery();
			}
			catch( Exception ex )
			{
				Global.LogError("MemberDetails.Read()\n" + 
					"  ERROR:" + ex.Message + "\n" +
					"  Path :" + m_sMemberID + "\n" + 
					"  SQL  :" + sSqlCmd + "\n" + 
					"  Conn.:" + Global.DB_CONN_STRING );
			}			
		}

		
		/// <summary>
		/// Read the form and put the new data intom the Members database
		/// NOTE: Email address must not be empty
		/// </summary>
		/// <param name="Request"> Request, used to get form data</param>
		public string ProcessEditMember( HttpRequest Request )
		{
			string sName	= (string)Request.Form["Name"].Trim();
			string sEmail	= (string)Request.Form["EMail"].Trim();
			string sState	= (string)Request.Form["State"].Trim();
			string sCountry	= (string)Request.Form["Country"].Trim();
			if( sEmail == "" )
			{
				return "The email address can not be blank!<br>";
			}

			//Update the Member database info
			string sSqlCmd = "UPDATE Member" +
						" SET Name       = '" + sName + "', " +
						"     Email      = '" + sEmail + "', " +
						"     State      = '" + sState + "', " +
						"     Country    = '" + sCountry + "' " +
						" WHERE MemberID = '"+ m_sMemberID +"';";			
			try
			{
				ADOConnection conn = new ADOConnection(Global.DB_CONN_STRING);
				conn.Open();
				ADOCommand cmd = new ADOCommand( sSqlCmd, conn );
				cmd.ExecuteNonQuery();
			}
			catch( Exception ex )
			{
				Global.LogError("MemberDetails.ProcessEditMember\n" + 
					"  ERROR:" + ex.Message + "\n" +
					"  SQL  :" + sSqlCmd + "\n" + 
					"  Conn.:" + Global.DB_CONN_STRING );
				return ex.Message;
			}

			//Save the new setting to the current session
			m_sName		= sName;
			m_sEmail	= sEmail;
			m_sState	= sState;
			m_sCountry= sCountry;
			return "";
		}
    }
}
