namespace Net
{
    using System;
	using System.Web;
	using System.Data.ADO;						//Database
	using System.Globalization;					//Date

    /// <summary>
    ///    This class supports the main index and section
    ///    index pages index.aspx, section.aspx.
    /// </summary>
    public class Section
    {
		public readonly string [,] SECTION_DETAILS = new string [,] 
		{
			{ "/COM/%",			"ActiveX/COM",					"Simple instructions on how to perform basic tasks with COM and ActiveX controls." },
			{ "/MFC/%",			"MFC Ideas",					"Notes on MFC based solutions to simple and more complex problems." },
			{ "/Win32/%",		"Win32 API Ideas",				"Notes on using the Windows Win32 API. This includes such things as Writing to the event log, using wsock32 and Registery events." },
			{ "/ASP/%",			"ASP/APSX Ideas",				"Active Server Pages are a quick and simple may to add value to your web. These articles show how to perform simple and common tasks. The source for this site is also included here." },
			{ "/HandyClasses/%","Handy functions and classes",	"Sometimes called code patterns, this set of pages has functions and classes that perform useful operations. This is an attempt at encouraging code reuse." },
			{ "/Java/%",		"Java Ideas",					"Java is new to me so I have jotted down a few points just to jog my memory. I will include Java and JavaScript in this area." },
			{ "/BookReviews/%", "Book Reviews",					"On occasion I read books on computer languages, development methods and Dilbert. My thoughs on these books are at this link." },
			{ "/CSharp/%",		"C# / .NET",					"I picked up C# and some ideas about .NET when I converted this site from ASP. Here some notes on these new technologies." }
		};
		private HttpResponse m_rs; 

        public Section( HttpResponse rs )
        {
			m_rs = rs;
        }

		/// <summary>
		///		Build the side index and popups. These popups will contain
		///		section descriptions and the page totals.
		/// </summary>
		public void MakeSideIndex()
		{
			int nID = 10;

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=0", 
				SECTION_DETAILS[0,0], 
				SECTION_DETAILS[0,1], 
				SECTION_DETAILS[0,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=1", 
				SECTION_DETAILS[1,0], 
				SECTION_DETAILS[1,1], 
				SECTION_DETAILS[1,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=2", 
				SECTION_DETAILS[2,0], 
				SECTION_DETAILS[2,1], 
				SECTION_DETAILS[2,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=7", 
				SECTION_DETAILS[7,0], 
				SECTION_DETAILS[7,1], 
				SECTION_DETAILS[7,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=3", 
				SECTION_DETAILS[3,0], 	 
				SECTION_DETAILS[3,1], 
				SECTION_DETAILS[3,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=4", 
				SECTION_DETAILS[4,0], 
				SECTION_DETAILS[4,1], 
				SECTION_DETAILS[4,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=5", 
				SECTION_DETAILS[5,0], 
				SECTION_DETAILS[5,1], 
				SECTION_DETAILS[5,2] );

			LinkAndToolTip( 
				nID++,
				"/Section.aspx?Section=6", 
				SECTION_DETAILS[6,0], 
				SECTION_DETAILS[6,1], 
				SECTION_DETAILS[6,2] );

			LinkAndToolTip( 
				nID++,
				"/DownLoads/index.aspx", 
				"", 
				"Handy Programs and Links", 
				"Over the years I have made a few tools of my own that I use to in my day to day coding that other may find useful. I have also included some links I could not survive without." );

			LinkAndToolTip( 
				nID++,
				"/Submission.aspx", 
				"", 
				"How to make a Submissions", 
				"If you have some code or a few pointers that you would like to share with other developers then draft a submission and I will put it on this page. If you are interested in making a submission. Look here for guidelines." );

		}

		/// <summary>
		///		Create a Div section that contains a table that will have the data
		///		and a note to display.
		///		<param name='nID'> unique ID for link. </param>
		///		<param name='sPath'> HREF  or link destination. </param>
		///		<param name='sFilter'> Filter to count matches '/COM/%' </param>
		///		<param name='sTitle'> Title of the tool tip. </param>
		///		<param name='sToolTip'> Message to display in the tool tip. </param>
		/// </summary>
		public void LinkAndToolTip( int nID, string sPath, string sFilter, string sTitle, string sToolTip )
		{
			int nNewCount = CountItems(sFilter, true );
			WL( "<a href = '"+sPath+"' onmouseover = 'inToolTip()' onmouseout = 'outToolTip()' id='"+nID+"'>" );
			WL( sTitle+"</a>" );
			if( nNewCount > 0 )
			{
				WL( "&nbsp;<img src='/images/new.gif'>" );
			}
			WL( "<br><br>" );

			WL( "<div id='div"+nID+"' " );
			WL( "	style='	display:none; position:absolute; z-index:1;	left:150px;'>" );
			WL( "	<table class='ToolTip' width='200' border='0' cellspacing='0' cellpadding='0'>" );
			WL( "		<tr><td background='/images/ToolTipTL.gif' width='8' height='8'></td>" );
			WL( "			<td background='/images/ToolTipT.gif'></td>" );
			WL( "			<td background='/images/ToolTipTR.gif' width='8'></td></tr>" );
			WL( "		<tr>" );
			WL( "			<td background='/images/ToolTipL.gif'></td>" );
			WL( "			<td bgcolor='#dbdbff'>" );
			WL( "			<b>&nbsp;"+sTitle+"</b><br>"+sToolTip );
			if( sFilter != "" )
			{
				WL( "			<br>"+CountItems(sFilter, false )+" Entries" );
				if( nNewCount > 0 )
				{
					WL( ",&nbsp;&nbsp; "+nNewCount+" <img src='/images/new.gif'>" );
				}
			}
			WL( "			</td>" );
			WL( "			<td background='/images/ToolTipR.gif'></td></tr>" );
			WL( "		<tr><td background='/images/ToolTipBL.gif' width='8' height='8'></td>" );
			WL( "			<td background='/images/ToolTipB.gif'></td>" );
			WL( "			<td background='/images/ToolTipBR.gif' width='8'></td></tr>" );
			WL( "	</table>" );
			WL( "</div>" );
			WL( "" );
		}

		/// <summary>
		///		Simple helper to abreviate code
		///		<param name='sLine'>Data to output</param>
		/// </summary>
		private void WL( string sLine )
		{
			m_rs.Write( sLine + "\n" );			
		}

		
		/// <summary>
		///		Count the number of items that match the filter. Used to count
		///		the articles in each directory. Also test bay age.
		///		<param name='sFilter'> Mask to limit to '/COM/%' </param>
		///		<param name='bResentOnly'> True if only count new items </param>
		/// </summary>
	    private static int CountItems( string sFilter, bool bResentOnly )
        {
			int nCount = 0;
			string sSqlCmd ="SELECT Updated FROM PAGE "+
							"WHERE Path LIKE '"+sFilter+"' ";
			try
			{
				//Open the data base connection
				ADODataReader dr;
				ADOConnection conn = new ADOConnection(Global.DB_CONN_STRING);
				conn.Open();
				ADOCommand cmd = new ADOCommand( sSqlCmd, conn );
				cmd.Execute( out dr);
				//Calculate the Date limit
				DateTime dtOldLimit = DateTime.Now.AddDays( -14.0 );
				// Display all data in the listing.
				while( dr.Read() )
				{
					if( bResentOnly )
					{
						if( dr.GetDateTime( 0 ) < dtOldLimit )
							continue;
					}
					nCount++;
					
				}
				dr.Close();
			}
			catch( Exception ex )
			{
				Global.LogError("CountItems\n" + 
					"  ERROR:" + ex.Message + "\n" +
					"  Mask :" + sFilter + "\n" + 
					"  SQL  :" + sSqlCmd + "\n" + 
					"  Conn.:" + Global.DB_CONN_STRING );
			}
			return nCount;
        }

		/// <summary>
		///		List all pages that match the filer criteria
		///		<param name='sFilter'> Mask like "/COM/%" </param>
		///		<param name='nRowCount'> Number of rows to display or -1 for all</param>
		/// </summary>
	    public void ListPageReferences( string sFilter, int nRowCount )
        {
			string sSqlCmd ="SELECT * FROM PAGE "+
							"WHERE Path LIKE '"+sFilter+"' "+
							"ORDER BY Updated DESC";
			try
			{
				//Open the data base connection
				ADODataReader dr;
				ADOConnection conn = new ADOConnection(Global.DB_CONN_STRING);
				conn.Open();
				ADOCommand cmd = new ADOCommand( sSqlCmd, conn );
				cmd.Execute( out dr);
				// Display all data in the listing.
				while( dr.Read() && nRowCount != 0 )
				{
					nRowCount--;
					DateTime dateUpdated = dr.GetDateTime( 6 );
					string sDate = dateUpdated.Format( "d-MMM-yyyy", DateTimeFormatInfo.InvariantInfo );
					string sLinkPath = dr.GetString( 9 );
					string sTitle = dr.GetString( 1 );
					m_rs.Write( TableLink( sLinkPath, sTitle, sDate, dr.GetString( 2 ) ) );
				}
				dr.Close();
			}
			catch( Exception ex )
			{
				Global.LogError("ListPageReferences\n" + 
					"  ERROR:" + ex.Message + "\n" +
					"  Mask :" + sFilter + "\n" + 
					"  SQL  :" + sSqlCmd + "\n" + 
					"  Conn.:" + Global.DB_CONN_STRING );
			}
        }
		
		/// <summary>
		///		Make a simple table entry to display link information. This is usually
		///		used by the above function but sometimes is used by the /Downloads/Index.aspx
		///		<param name='sLink'> link destination </param>
		///		<param name='sTitle'> Title to display </param>
		///		<param name='sDate'> Dtae of link </param>
		///		<param name='sComment'> Comment to span both cells on the bottom</param>
		/// </summary>
		public static string TableLink( string sLink, string sTitle, string sDate, string sComment ) 
		{
			string sHtml = "";
			sHtml += "<tr bgcolor='cornflowerblue'><td width=600>\n";
			sHtml += "   <a href='"+sLink+"'>"+sTitle+"</a></td>\n";
			sHtml += "	  <td width=100 align='right'>"+sDate+"</td></tr>\n";
			sHtml += "<tr><td colspan=2>"+sComment+"<br><br></td></tr>\n";
			sHtml += "\n";
			return sHtml;
		}
    }
}
