namespace Net
{
    using System;
    using System.Web;
	using System.Data.ADO;						//Database
	using System.Globalization;					//Date


    /// <summary>
    ///    Summary description for SearchPage.
    /// </summary>
    public class SearchPage
    {
		//Attributes
	
		/// <summary>
		/// Constructor
		/// </summary>
		public SearchPage()
		{
		}

		/// <summary>
		/// Write the users request information to the Searches database.
		/// </summary>
		/// <param name="sSearchText">Text that was requested in the search</param>
		/// <param name="sCaller">IP address or user requesting search</param>
		public void RecordSearchText( string sSearchText, string sCaller )
		{
			DateTime dtNow = DateTime.Now;
			string sNow = dtNow.Format( "G", DateTimeFormatInfo.CurrentInfo );

			//Update the Member database info
			string sSqlCmd = 
				"INSERT INTO Search (IPAddress,SearchString,SearchTime) VALUES "+
				"('"+sCaller+"','"+sSearchText+"','"+sNow+"')";
			try
			{
				ADOConnection conn = new ADOConnection(Global.DB_CONN_STRING);
				conn.Open();
				ADOCommand cmd = new ADOCommand( sSqlCmd, conn );
				cmd.ExecuteNonQuery();
			}
			catch( Exception ex )
			{
				Global.LogError("SearchPage.RecordSearchText\n" + 
					"  ERROR:" + ex.Message + "\n" +
					"  SQL  :" + sSqlCmd + "\n" + 
					"  Conn.:" + Global.DB_CONN_STRING );
			}
		}

		/// <summary>
		/// Perform the Text search and display the results.
		/// </summary>
		/// <param name="sSearchText">Text to search for</param>
		/// <param name="sMapPathRoot">Root of web to add to file names</param>
		/// <param name="Response">Output object</param>
		public void PerformSoftwareSearch( string sSearchText, string sMapPathRoot, HttpResponse Response )
		{
			int nBuild = 0;
			int nHitCount = 0;
			try
			{
				MCTAINSHCOMLib.SearchPage sp = new MCTAINSHCOMLib.SearchPage();
				nBuild = sp.BuildNo();
				sp.bsSearchString = sSearchText;
				sp.SetMapPath( sMapPathRoot );

				//	Dough hits should be redirected here
				string sLower = sSearchText.ToLower();
				if(	sLower.IndexOf( "dough" ) != -1 )
					Response.Redirect( "http://family.mctainsh.com/dough" );

				//Open and search the database	
				int nOpened = sp.OpenDatabase( Global.DB_CONN_STRING );
				string sHitPath;
	
				do
				{ 
					//Get next search match	
					sHitPath = sp.GetHit();
					if( sHitPath != "" )
					{
						nHitCount = nHitCount + 1;	
						Response.Write( Section.TableLink(
							sHitPath, sp.bsHitTitle, "&nbsp;&nbsp;&nbsp;&nbsp;", 
							sp.bsHitSummary ) );
					}
				} while( sHitPath != "" );
					
			}
			catch( Exception ex ) 
			{
				Response.Write( ex.ToString() );
				Global.LogError("SearchPage.aspx\n" + 
					"  ERROR      :" + ex.Message + "\n" +
					"  Build      :" + nBuild + "\n" +
					"  Looking for:" + sSearchText );
			}
			
			//Display an unsucessfull message if no hits found
			if( nHitCount == 0 )
			{
				Response.Write( "<tr><td colspan=2>" );	
				Response.Write( "<h3>No Match for '" + sSearchText + "'</h3>" );	
				Response.Write( "</td></tr>" );	
			}

			//Display builder version
			Response.Write( "		<tr><td colspan=2 align=right>" );	
			Response.Write( "			<font size=1>Using search engine build " + nBuild + ".<font>" );	
			Response.Write( "		</td></tr>" );	
		}
    }
}
