
<!-- #include virtual="/Inc/NoteHeader.inc" --> 


<h4>Description.</h4>
      
<p>It is often necessary for a user to browse the network to identify
a machine or shared resource. The following function allows the network resources
to be enumerated and expanded like branches on a tree.</p>
   
<h4>How to use it.</h4>

<p>You MUST add <code>Mpr.lib </code> to the build librarys otherwise you will
get a link error. To do this select Project->Settings to open the Project 
settings dialog. Select the Link tab and from the drop down box select 
the General Catagory. In the Object/Link modules edit type in <code>mpr.lib</code></p>

<p>The following function starts an enumeration of the newtork
starting at the root. If you have a pointer to a <code>NETRESOURCE</code>
it can be used in place of NULL to expand that branch of the tree. In
this example <code>EnumNetwork</code> calls itself (a bad idea) to expand the branches.
Run the application in DEBUG to view the output in the trace log.</p>

<pre>
    EnumNetwork<font color="#FF0000">(</font> NULL<font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">" - "</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<h4>The Enumerate function.</h4>

<p>This is the actual enumeration function. It first opens the network resource
then enumerates it. Each enumeration is displayed in the TRACE then used
to re-enter this function to expand itself.</p>

<pre>
<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//        Enumerate the given network resource. </font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//        pNetResource    NULL to enumerate root or a pointer</font>
<font color="#006600">//                        to a NETRESOURCE to enumerate.</font>
<font color="#006600">//        sIndent         Used only for display of data it allows</font>
<font color="#006600">//                        re-enternat calls to be pushed further across page.</font>
<font color="#006600">//RETURN:</font>
<font color="#006600">//        true if the resource has sub items.</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//        8-11-2000, 8:20:31 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
<font color="#0088FF">bool</font> EnumNetwork<font color="#FF0000">(</font> NETRESOURCE <font color="#FF0000">*</font><font color="#0088FF">const</font> pNetResource<font color="#FF0000">,</font> CString sIndent <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    <font color="#006600">//TRACE( _T("EnumNetwork( %p )\n"), pNetResource );</font>

    <font color="#006600">//</font>
    <font color="#006600">//Setup</font>
    <font color="#006600">//</font>
    DWORD dwResult<font color="#FF0000">;</font>      
    HANDLE hEnum<font color="#FF0000">;</font>      
    DWORD cbBuffer <font color="#FF0000">=</font> <font color="#6600FF">16</font><font color="#FF0000">*</font><font color="#6600FF">1024</font><font color="#FF0000">;</font>
    DWORD cEntries <font color="#FF0000">=</font> <font color="#6600FF">0xFFFFFFFF</font><font color="#FF0000">;</font>      
    LPNETRESOURCE lpnrDrv<font color="#FF0000">;</font>      
    DWORD i<font color="#FF0000">;</font>
    dwResult <font color="#FF0000">=</font> WNetOpenEnum<font color="#FF0000">(</font>
                pNetResource <font color="#FF0000">?</font>  RESOURCE_GLOBALNET  <font color="#FF0000">:</font> RESOURCE_CONTEXT<font color="#FF0000">,</font>
                RESOURCETYPE_ANY<font color="#FF0000">,</font>
                <font color="#6600FF">0</font><font color="#FF0000">,</font>                               
                pNetResource<font color="#FF0000">,</font>
                <font color="#FF0000">&</font>hEnum <font color="#FF0000">)</font><font color="#FF0000">;</font>   
    
    <font color="#006600">//Was the read sucessfull</font>
    <font color="#0088FF">if</font> <font color="#FF0000">(</font>dwResult <font color="#FF0000">!</font><font color="#FF0000">=</font> NO_ERROR<font color="#FF0000">)</font>      
    <font color="#FF0000">{</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"%s *** ERROR %d - Cannot enumerate network\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
            sIndent<font color="#FF0000">,</font> dwResult <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#0088FF">false</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font> 
    
    <font color="#006600">//</font>
    <font color="#006600">//Get items until no more remain.</font>
    <font color="#006600">//</font>
    <font color="#0088FF">do</font>      
    <font color="#FF0000">{</font>
        lpnrDrv <font color="#FF0000">=</font> <font color="#FF0000">(</font>LPNETRESOURCE<font color="#FF0000">)</font> GlobalAlloc<font color="#FF0000">(</font> GPTR<font color="#FF0000">,</font> cbBuffer <font color="#FF0000">)</font><font color="#FF0000">;</font>
        dwResult <font color="#FF0000">=</font> WNetEnumResource<font color="#FF0000">(</font> hEnum<font color="#FF0000">,</font> <font color="#FF0000">&</font>cEntries<font color="#FF0000">,</font> lpnrDrv<font color="#FF0000">,</font> <font color="#FF0000">&</font>cbBuffer <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">if</font> <font color="#FF0000">(</font>dwResult <font color="#FF0000">=</font><font color="#FF0000">=</font> NO_ERROR<font color="#FF0000">)</font>         
        <font color="#FF0000">{</font>
            <font color="#006600">//Scann through the results</font>
            <font color="#0088FF">for</font><font color="#FF0000">(</font> i <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> i <font color="#FF0000"><</font> cEntries<font color="#FF0000">;</font> i<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>            
            <font color="#FF0000">{</font>
                CString sNameRemote <font color="#FF0000">=</font> lpnrDrv<font color="#FF0000">[</font>i<font color="#FF0000">]</font>.lpRemoteName<font color="#FF0000">;</font>
                <font color="#0088FF">if</font><font color="#FF0000">(</font> sNameRemote.IsEmpty<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
                <font color="#FF0000">{</font>
                    sNameRemote <font color="#FF0000">=</font> lpnrDrv<font color="#FF0000">[</font>i<font color="#FF0000">]</font>.lpComment<font color="#FF0000">;</font>
                <font color="#FF0000">}</font>

                <font color="#006600">//Save the resource information</font>
                TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"%s %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> sIndent<font color="#FF0000">,</font> sNameRemote <font color="#FF0000">)</font><font color="#FF0000">;</font>
                    
                <font color="#006600">//Here is where we delve deeper into the tree by</font>
                <font color="#006600">//calling our self with current NETRESOURCE.</font>
                <font color="#006600">//We don't bother with shares as they  are branch ends.</font>
                <font color="#006600">//and can be enumerated with CFileFind.</font>
                <font color="#0088FF">if</font><font color="#FF0000">(</font> lpnrDrv<font color="#FF0000">[</font>i<font color="#FF0000">]</font>.dwDisplayType <font color="#FF0000">!</font><font color="#FF0000">=</font> RESOURCEDISPLAYTYPE_SHARE <font color="#FF0000">)</font>
                    EnumNetwork<font color="#FF0000">(</font> <font color="#FF0000">&</font><font color="#FF0000">(</font>lpnrDrv<font color="#FF0000">[</font>i<font color="#FF0000">]</font><font color="#FF0000">)</font><font color="#FF0000">,</font> sIndent <font color="#FF0000">+</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"  "</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#FF0000">}</font>
        <font color="#FF0000">}</font>         
        GlobalFree<font color="#FF0000">(</font> <font color="#FF0000">(</font>HGLOBAL<font color="#FF0000">)</font> lpnrDrv <font color="#FF0000">)</font><font color="#FF0000">;</font>      
        <font color="#0088FF">if</font><font color="#FF0000">(</font> dwResult <font color="#FF0000">!</font><font color="#FF0000">=</font> ERROR_NO_MORE_ITEMS <font color="#FF0000">&</font><font color="#FF0000">&</font> dwResult <font color="#FF0000">!</font><font color="#FF0000">=</font> NO_ERROR <font color="#FF0000">)</font>
        <font color="#FF0000">{</font>            
            TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"%s *** ERROR %d - Cannot complete network enumeration\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font>
                sIndent<font color="#FF0000">,</font> dwResult <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">break</font><font color="#FF0000">;</font>         
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> dwResult <font color="#FF0000">!</font><font color="#FF0000">=</font> ERROR_NO_MORE_ITEMS <font color="#FF0000">)</font><font color="#FF0000">;</font>      

    <font color="#006600">//</font>
    <font color="#006600">//Let go and go home</font>
    <font color="#006600">//</font>
    WNetCloseEnum<font color="#FF0000">(</font>hEnum<font color="#FF0000">)</font><font color="#FF0000">;</font>   
<font color="#FF0000">}</font>
</pre>



<!-- #include virtual="/Inc/NoteFooter.inc" --> 




