


<!-- #include virtual="/Inc/NoteHeader.inc" --> 

	<h4>Description.</h4>
      
		      
    <p>The SHBrosweForFolder is not a simple function to call to this article
    provides a sample that should cover most requirements. In particular it
    covers setting the initial path and display the path as the user selects it
    which not as straight forward as you might expect.</p>      
      
      
    <h4>What to do.</h4>
      
		<p>
		Start by adding support for the Shell32 API including the following <code>StdAfx.h</code>
		</p>
<pre>
<font color="#0088FF">#include</font> <font color="#FF0000"><</font>shlobj.h<font color="#FF0000">></font>
</pre>    
     
		Next add the following callback and usage code where the call is to be made.
		
<pre>
<font color="#006600">//////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//The call back is used to set the initial directory and</font>
<font color="#006600">//display the selected path in thhe top of the box.</font>
<font color="#0088FF">int</font> CALLBACK BrowseCallbackProc<font color="#FF0000">(</font>HWND hwnd<font color="#FF0000">,</font>UINT uMsg<font color="#FF0000">,</font>LPARAM lp<font color="#FF0000">,</font> LPARAM pData<font color="#FF0000">)</font> 
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"BrowseCallbackProc(0x%x,%d,%p,%p)\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> hwnd<font color="#FF0000">,</font> uMsg<font color="#FF0000">,</font> lp<font color="#FF0000">,</font> pData <font color="#FF0000">)</font><font color="#FF0000">;</font>
    TCHAR szDir<font color="#FF0000">[</font>MAX_PATH<font color="#FF0000">]</font><font color="#FF0000">;</font>
    
    <font color="#0088FF">switch</font><font color="#FF0000">(</font>uMsg<font color="#FF0000">)</font> 
    <font color="#FF0000">{</font>
    <font color="#0088FF">case</font> BFFM_INITIALIZED<font color="#FF0000">:</font> 
        <font color="#006600">//Initial directory is set here</font>
        strcpy<font color="#FF0000">(</font> szDir<font color="#FF0000">,</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"c:\\temp"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">{</font>
            <font color="#006600">// WParam is TRUE since you are passing a path.</font>
            <font color="#006600">// It would be FALSE if you were passing a pidl.</font>
            SendMessage<font color="#FF0000">(</font>hwnd<font color="#FF0000">,</font>BFFM_SETSELECTION<font color="#FF0000">,</font>TRUE<font color="#FF0000">,</font><font color="#FF0000">(</font>LPARAM<font color="#FF0000">)</font>szDir<font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#0088FF">break</font><font color="#FF0000">;</font>
    <font color="#0088FF">case</font> BFFM_SELCHANGED<font color="#FF0000">:</font> 
        <font color="#006600">// Set the status window to the currently selected path.</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> SHGetPathFromIDList<font color="#FF0000">(</font> <font color="#FF0000">(</font>LPITEMIDLIST<font color="#FF0000">)</font>lp <font color="#FF0000">,</font>szDir <font color="#FF0000">)</font> <font color="#FF0000">)</font> 
        <font color="#FF0000">{</font>
            SendMessage<font color="#FF0000">(</font>hwnd<font color="#FF0000">,</font>BFFM_SETSTATUSTEXT<font color="#FF0000">,</font><font color="#6600FF">0</font><font color="#FF0000">,</font><font color="#FF0000">(</font>LPARAM<font color="#FF0000">)</font>szDir<font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#0088FF">break</font><font color="#FF0000">;</font>
    <font color="#0088FF">default</font><font color="#FF0000">:</font>
        <font color="#0088FF">break</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">return</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>



<font color="#006600">//////////////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//This is where the file dialog is to be used</font>
<font color="#0088FF">void</font> CSHBrowseForFolderDlg<font color="#FF0000">:</font><font color="#FF0000">:</font>OnButton1<font color="#FF0000">(</font><font color="#FF0000">)</font> 
<font color="#FF0000">{</font>
    LPMALLOC pMalloc<font color="#FF0000">;</font>
    
    <font color="#0088FF">if</font><font color="#FF0000">(</font> SUCCEEDED<font color="#FF0000">(</font> SHGetMalloc<font color="#FF0000">(</font> <font color="#FF0000">&</font>pMalloc <font color="#FF0000">)</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font> 
    <font color="#FF0000">{</font>
        TCHAR szTitle<font color="#FF0000">[</font><font color="#FF0000">]</font> <font color="#FF0000">=</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Blah blah... this is quite cool stuff."</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        BROWSEINFO bi<font color="#FF0000">;</font>
        ZeroMemory<font color="#FF0000">(</font> <font color="#FF0000">&</font>bi<font color="#FF0000">,</font> <font color="#0088FF">sizeof</font><font color="#FF0000">(</font> bi <font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        bi.hwndOwner <font color="#FF0000">=</font> NULL<font color="#FF0000">;</font>
        bi.pszDisplayName <font color="#FF0000">=</font> NULL<font color="#FF0000">;</font>
        bi.lpszTitle <font color="#FF0000">=</font> szTitle<font color="#FF0000">;</font>
        bi.pidlRoot <font color="#FF0000">=</font> NULL<font color="#FF0000">;</font>
        bi.ulFlags <font color="#FF0000">=</font> BIF_RETURNONLYFSDIRS <font color="#FF0000">|</font> BIF_STATUSTEXT <font color="#FF0000">|</font> BIF_EDITBOX<font color="#FF0000">;</font>
        bi.lpfn <font color="#FF0000">=</font> BrowseCallbackProc<font color="#FF0000">;</font>
        
        LPITEMIDLIST pidl <font color="#FF0000">=</font> SHBrowseForFolder<font color="#FF0000">(</font> <font color="#FF0000">&</font>bi <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">if</font><font color="#FF0000">(</font> pidl <font color="#FF0000">)</font> 
        <font color="#FF0000">{</font>
            TCHAR szDir<font color="#FF0000">[</font>MAX_PATH<font color="#FF0000">]</font><font color="#FF0000">;</font>
            <font color="#0088FF">if</font><font color="#FF0000">(</font> SHGetPathFromIDList<font color="#FF0000">(</font> pidl<font color="#FF0000">,</font> szDir <font color="#FF0000">)</font> <font color="#FF0000">)</font> 
            <font color="#FF0000">{</font>
                MessageBox<font color="#FF0000">(</font>szDir<font color="#FF0000">,</font><font color="#FF00FF">"Picked"</font><font color="#FF0000">,</font>MB_OK<font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#FF0000">}</font>
            <font color="#0088FF">else</font>
            <font color="#FF0000">{</font>
                TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"ERROR : SHGetPathFromIDList failed at %s, %d\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
                    __FILE__<font color="#FF0000">,</font> __LINE__ <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#FF0000">}</font>
            pMalloc<font color="#FF0000">-</font><font color="#FF0000">></font>Free<font color="#FF0000">(</font>pidl<font color="#FF0000">)</font><font color="#FF0000">;</font> 
            pMalloc<font color="#FF0000">-</font><font color="#FF0000">></font>Release<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
        <font color="#0088FF">else</font>
        <font color="#FF0000">{</font>
            TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"User selected Cancel\n"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#FF0000">}</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">else</font>
    <font color="#FF0000">{</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"ERROR : SHGetMalloc failed at %s, %d\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
            __FILE__<font color="#FF0000">,</font> __LINE__ <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

	

<!-- #include virtual="/Inc/NoteFooter.inc" --> 




