


<!-- #include virtual="/Inc/NoteHeader.inc" -->  
<img src='/images/DownLoad.gif'>&nbsp;<a href="CWinSockTester.zip">Download Client and Server files - 31 Kb</a>
<h1>Description.</h1>
<p>Sockets are a simple way to communicate between computers and processes 
without the hassle of security and registration. You simply create 
 a client and a server and away you go. This tutorial shows how 
 to use my <code>CWinSock2Async</code> or Microsoft's <code>CAsyncSocket</code>. 
 Both are similar but <code>CWinSock2Async</code> does not require 
 MFC support so can be used in ATL controls, Services and other 
 areas where MFC is not required. 
<ul>
	<li><a href="#_ProjectSettings">Project settings</a></li>
	<li><a href="#_ProcessFlow">Process flow</a></li>
	<li><a href="#_CreateClient">Create Client</a></li>
	<li><a href="#_CreateServer">Create Server</a></li>
	<li><a href="#_ThingsToWatchOutFor">Things to watch out for</a></li>
</ul>

<h1>How this tutorial works.</h1>

We will create two applications, one a server and one a client. The server will start 
and listen for connections. The client will connect to the server 
to send and receive data. The sample applications and the <code>CWinSockAsync</code> 
files are included in the downloads. 
<h1>Project settings.<a name="_ProjectSettings"></a></h1> 

It is necessary to add the following include files to a global header such as <code>StdAfx.h</code>. 
Note only the <code>WinSock2.h</code> is necessary if you are using 
MFC. You MUST also add the <code>Ws2_32.lib</code> to be linked into 
your application. To do this select Project->Settings to open the 
Project settings dialog. Select the Link tab and from the drop down 
box select the General Category. In the Object/Link modules add <code>Ws2_32.lib</code>. 
<pre>
    <font color="#006600">//Needed for CWinSock2Async</font>
    <font color="#0088FF">#include</font> <font color="#FF0000"><</font>winsock2.h<font color="#FF0000">></font>
    <font color="#0088FF">#include</font> <font color="#FF00FF">"WinSock2Async.h"</font>
    <font color="#0088FF">#include</font> <font color="#FF0000"><</font>windows.h<font color="#FF0000">></font>       <font color="#006600">//Not necessary if using MFC</font>
    <font color="#0088FF">#include</font> <font color="#FF0000"><</font>TChar.h<font color="#FF0000">></font>         <font color="#006600">//..</font>
    <font color="#0088FF">#include</font> <font color="#FF0000"><</font>assert.h<font color="#FF0000">></font>        <font color="#006600">//..</font>
</pre>

<h1>Process flow.<a name="_ProcessFlow"></a></h1>

<p>The basic socket process (without errors) is;</p>
<p> 
<center><img src="SocketFlow.gif"></center>
</p>
<p>Details of the process flow are described in later sections. </p>

<h1>Create Client.<a name="_CreateClient"></a></h1>

<p>Create a new project or open an existing project. Put <code>WinSock2Async.h</code> 
and <code>WinSock2Async.cpp</code> in the project directory. </p>

<p>Add <code>WinSock2Async.cpp</code> to the project work space.</p>

<p>Create a new class <code>CSockClient</code> derived from <code>CWinSock2Async</code>. 
From the menu select <u>I</u>nsert-&gt;<u>N</u>ew Class ..., set the 
<u>N</u>ame as <code>CSockClient</code> and <u>B</u>ase class of <code>CWinSock2Async</code>, 
public.</p>

<p>Add the following prototypes to <code>SockClient.h</code> </p>

<pre>
<font color="#006600">//Event handlers</font>
<font color="#0088FF">private</font><font color="#FF0000">:</font>
    <font color="#0088FF">void</font> OnRecieve<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">void</font> OnSend<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">void</font> OnClose<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

<p>Implement the<code> On...</code> handlers to display a message about 
each event in the <code>SockClient.cpp</code> file as follows</p>

<pre> 
<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      An FD_WRITE network event is recorded when a socket is first connected </font>
<font color="#006600">//      with connect/WSAConnect or accepted with accept/WSAAccept, and then </font>
<font color="#006600">//      after a send fails with WSAEWOULDBLOCK and buffer space becomes </font>
<font color="#006600">//      available. Therefore, an application can assume that sends are </font>
<font color="#006600">//      possible starting from the first FD_WRITE network event setting and </font>
<font color="#006600">//      lasting until a send returns WSAEWOULDBLOCK. After such a failure the </font>
<font color="#006600">//      application will find out that sends are again possible when OnSend </font>
<font color="#006600">//      is fired.</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      nError    Error code</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//      26-11-2000, 19:46:38 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
<font color="#0088FF">void</font> CSockClient<font color="#FF0000">:</font><font color="#FF0000">:</font>OnSend<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CSockClient::OnSend( %d )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>


<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      The FD_CLOSE network event is recorded when a close indication is </font>
<font color="#006600">//      received for the virtual circuit corresponding to the socket. In TCP </font>
<font color="#006600">//      terms, this means that the FD_CLOSE is recorded when the connection </font>
<font color="#006600">//      goes into the TIME WAIT or CLOSE WAIT states. This results from the </font>
<font color="#006600">//      remote end performing a shutdown on the send side or a closesocket. </font>
<font color="#006600">//      FD_CLOSE being posted after all data is read from a socket. An </font>
<font color="#006600">//      application should check for remaining data upon receipt of FD_CLOSE </font>
<font color="#006600">//      to avoid any possibility of losing data.</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      nError    Error code</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//      26-11-2000, 16:23:21 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
<font color="#0088FF">void</font> CSockClient<font color="#FF0000">:</font><font color="#FF0000">:</font>OnClose<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CSockClient::OnClose( %d )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#006600">//Check for any remaining data</font>
    <font color="#0088FF">char</font> chBuff<font color="#FF0000">[</font>WINSOCK_READ_BUFF_SIZE<font color="#FF0000">+</font><font color="#6600FF">1</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> Receive<font color="#FF0000">(</font> chBuff<font color="#FF0000">,</font> WINSOCK_READ_BUFF_SIZE <font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//TODO : Process the read data.</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

<p>Note how OnClose empties the buffer before exiting. Now implement 
 the <code>OnRecieve</code> event to read in any data. Note, a 
 read must be performed to ensure further events. This is where 
 you process the incoming data.</p>

<pre>
<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      Received data event.</font>
<font color="#006600">//      For FD_READ network event, network event recording and event object </font>
<font color="#006600">//      signalling are level-triggered. This means that if Receive() routine</font>
<font color="#006600">//      is called and data is still in the input buffer after the call, the </font>
<font color="#006600">//      FD_READ event is recorded and FD_READ event object is set. This allows </font>
<font color="#006600">//      an application to be event-driven and not be concerned with the amount </font>
<font color="#006600">//      of data that arrives at any one time</font>
<font color="#006600">//      With these semantics, an application need not read all available data </font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      nError    Error code</font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//      26-11-2000, 16:54:46 by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
<font color="#0088FF">void</font> CSockClient<font color="#FF0000">:</font><font color="#FF0000">:</font>OnRecieve<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CSockClient::OnRecieve( %d )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">char</font> chBuff<font color="#FF0000">[</font>WINSOCK_READ_BUFF_SIZE<font color="#FF0000">+</font><font color="#6600FF">1</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">int</font> nRead<font color="#FF0000">;</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> <font color="#FF0000">(</font> nRead <font color="#FF0000">=</font> Receive<font color="#FF0000">(</font> chBuff<font color="#FF0000">,</font> WINSOCK_READ_BUFF_SIZE <font color="#FF0000">)</font> <font color="#FF0000">)</font> <font color="#FF0000">></font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#006600">//TODO: Use the data here...</font>
        <font color="#006600">//Display the input data</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Recieved( "</font><font color="#FF0000">)</font>  <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nPos <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nPos <font color="#FF0000"><</font> nRead<font color="#FF0000">;</font> nPos<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
            TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"%c"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> chBuff<font color="#FF0000">[</font>nPos<font color="#FF0000">]</font>  <font color="#FF0000">)</font><font color="#FF0000">;</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">" )\n"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

<p>Now create a socket object and connect to the server. Do this where 
it will not go out of scope during use. A member attribute is 
suitable. </p>

<pre>
<font color="#0088FF">#include</font> <font color="#FF00FF">"SockClient.h"</font>
....
    <font color="#0088FF">if</font><font color="#FF0000">(</font> CSockListener<font color="#FF0000">:</font><font color="#FF0000">:</font>SocketInit<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
        <font color="#006600">//TODO : Some error handling</font>
....
    CSockClient m_sock<font color="#FF0000">;</font>
....
    <font color="#0088FF">if</font><font color="#FF0000">(</font> <font color="#FF0000">!</font>m_sock.Create<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">|</font><font color="#FF0000">|</font>
        <font color="#FF0000">!</font>m_sock.Connect<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"127.0.0.1"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> <font color="#6600FF">1055</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        TCHAR szErrorMsg<font color="#FF0000">[</font>WSA_ERROR_LEN<font color="#FF0000">]</font><font color="#FF0000">;</font>
        CSockClient<font color="#FF0000">:</font><font color="#FF0000">:</font>WSAGetLastErrorMessage<font color="#FF0000">(</font> szErrorMsg <font color="#FF0000">)</font><font color="#FF0000">;</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Socket Create/Connect failed Error: %s"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szErrorMsg <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#FF0000">-</font><font color="#6600FF">1</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
...
    <font color="#006600">//When it is time to send</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> m_sock.IsConnected<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
        m_sock.Send<font color="#FF0000">(</font> <font color="#FF00FF">"Hello"</font><font color="#FF0000">,</font> <font color="#6600FF">5</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

</pre>

<h1>Create Server.<a name="_CreateServer"></a></h1>

<p>Create a new project or open an existing project. Put <code>WinSock2Async.h 
	</code>, <code>WinSock2Async.cpp</code>, <code>SockClient.cpp</code> 
	and <code>SockClient.h</code> from the client project into this 
	project directory. </p>

<p>Add <code>WinSock2Async.cpp</code> and <code>SockCient.cpp</code> 
	to the project work space.</p>

<p>From the menu select <u>I</u>nsert-&gt;<u>N</u>ew Class ..., set 
	the <u>N</u>ame as <code>CSockListener</code> and <u>B</u>ase 
	class of <code>CWinSock2Async</code>, public.</p>

<p>Add the following prototypes to the <code>SockListener.h</code> 
file.</p>

<pre>
... Before the <font color="#0088FF">class</font> definition
<font color="#0088FF">#include</font> <font color="#FF00FF">"SockClient.h"</font>

... In the <font color="#0088FF">class</font> definition

<font color="#006600">//Event handlers</font>
<font color="#0088FF">private</font><font color="#FF0000">:</font>
    <font color="#0088FF">void</font> OnAccept<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>

<font color="#006600">//Attributes</font>
<font color="#0088FF">private</font><font color="#FF0000">:</font>
    CSockClient<font color="#FF0000">*</font> m_psockClient<font color="#FF0000">;</font>    <font color="#006600">//Client connection</font>
</pre>

<p>Implement the <code>OnAccept</code> handler to create a client connection and return 
 it to communicate on. Note: this implementation allows only a 
 single client at any one time. If another client attempts to connect 
 the previous client will be disconnected.</p>
<pre>
<font color="#006600">// ***************************************************************************</font>
<font color="#006600">//DESCRIPTION:</font>
<font color="#006600">//      Called by the framework to notify a listening socket that it can </font>
<font color="#006600">//      accept pending connection requests by calling the Accept member </font>
<font color="#006600">//      function.</font>
<font color="#006600">//PARAMS:</font>
<font color="#006600">//      The most recent error on a socket. The following error codes </font>
<font color="#006600">//      applies to the OnAccept member function: </font>
<font color="#006600">//       0            The function executed successfully.</font>
<font color="#006600">//       WSAENETDOWN  The Windows Sockets implementation detected </font>
<font color="#006600">//                    that the network subsystem failed. </font>
<font color="#006600">//CREATED:</font>
<font color="#006600">//      2-12-2000, 7:10:28 AM by john@mctainsh.com</font>
<font color="#006600">// ***************************************************************************</font>
<font color="#0088FF">void</font> CSockListener<font color="#FF0000">:</font><font color="#FF0000">:</font>OnAccept<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CSockListener::OnAccept(%d)\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#006600">//Close of the old connection and create a new one</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> m_psockClient <font color="#FF0000">)</font>
        <font color="#0088FF">delete</font> m_psockClient<font color="#FF0000">;</font>
    Sleep<font color="#FF0000">(</font> <font color="#6600FF">1</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>

    <font color="#006600">//Create the new connection</font>
    m_psockClient <font color="#FF0000">=</font> <font color="#0088FF">new</font> CSockClient<font color="#FF0000">;</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> Accept<font color="#FF0000">(</font> m_psockClient <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        <font color="#0088FF">char</font> szErrMessage<font color="#FF0000">[</font>WSA_ERROR_LEN<font color="#FF0000">+</font><font color="#6600FF">1</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
        WSAGetLastErrorMessage<font color="#FF0000">(</font> szErrMessage <font color="#FF0000">)</font><font color="#FF0000">;</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"ERROR on Accept %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szErrMessage <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>

    <font color="#006600">//Display connection details</font>
    <font color="#0088FF">char</font> szAddress<font color="#FF0000">[</font><font color="#6600FF">17</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">int</font> nPort<font color="#FF0000">;</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> m_psockClient<font color="#FF0000">-</font><font color="#FF0000">></font>GetPeerName<font color="#FF0000">(</font> szAddress<font color="#FF0000">,</font> <font color="#FF0000">&</font>nPort <font color="#FF0000">)</font> <font color="#FF0000">=</font><font color="#FF0000">=</font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
        TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"Connected to %s on port %d\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szAddress<font color="#FF0000">,</font> nPort <font color="#FF0000">)</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>

... Also Modify the CSockClient<font color="#FF0000">:</font><font color="#FF0000">:</font>OnRecieve as follows
<font color="#0088FF">void</font> CSockClient<font color="#FF0000">:</font><font color="#FF0000">:</font>OnRecieve<font color="#FF0000">(</font> <font color="#0088FF">int</font> nError <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CSockClient::OnRecieve( %d )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> nError <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">char</font> chBuff<font color="#FF0000">[</font>WINSOCK_READ_BUFF_SIZE<font color="#FF0000">+</font><font color="#6600FF">1</font><font color="#FF0000">]</font><font color="#FF0000">;</font>
    <font color="#0088FF">int</font> nRead<font color="#FF0000">;</font>
    <font color="#0088FF">while</font><font color="#FF0000">(</font> <font color="#FF0000">(</font> nRead <font color="#FF0000">=</font> Recieve<font color="#FF0000">(</font> chBuff<font color="#FF0000">,</font> WINSOCK_READ_BUFF_SIZE <font color="#FF0000">)</font> <font color="#FF0000">)</font> <font color="#FF0000">></font> <font color="#6600FF">0</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
       <font color="#006600">//TODO: Use the data here...</font>
       <font color="#006600">//Modify the data and echo</font>
       <font color="#0088FF">for</font><font color="#FF0000">(</font> <font color="#0088FF">int</font> nPos <font color="#FF0000">=</font> <font color="#6600FF">0</font><font color="#FF0000">;</font> nPos <font color="#FF0000"><</font> nRead<font color="#FF0000">;</font> nPos<font color="#FF0000">+</font><font color="#FF0000">+</font> <font color="#FF0000">)</font>
       <font color="#FF0000">{</font>
           TRACE<font color="#FF0000">(</font> <font color="#FF00FF">"%c "</font><font color="#FF0000">,</font> chBuff<font color="#FF0000">[</font>nPos<font color="#FF0000">]</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
           chBuff<font color="#FF0000">[</font>nPos<font color="#FF0000">]</font> <font color="#FF0000">=</font> chBuff<font color="#FF0000">[</font>nPos<font color="#FF0000">]</font> <font color="#FF0000">+</font> <font color="#6600FF">1</font><font color="#FF0000">;</font>
       <font color="#FF0000">}</font>
       Send<font color="#FF0000">(</font> chBuff<font color="#FF0000">,</font> nRead <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
<font color="#FF0000">}</font>
</pre>

<p>Now setup the listener in your applications initialisation routine.</p>

<pre>
#Include <font color="#FF00FF">"SockListener.h"</font>

...

    <font color="#006600">//Initialise Winsock API</font>
    <font color="#0088FF">if</font><font color="#FF0000">(</font> CSockListener<font color="#FF0000">:</font><font color="#FF0000">:</font>SocketInit<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>
        printf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"*** WinSock API could not be initialised\n"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#FF0000">-</font><font color="#6600FF">1</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>

    <font color="#006600">//Create a simple listener</font>
    CSockListener sockListener<font color="#FF0000">;</font>

    <font color="#0088FF">if</font><font color="#FF0000">(</font> <font color="#FF0000">!</font>sockListener.Create<font color="#FF0000">(</font> <font color="#6600FF">392</font> <font color="#FF0000">)</font> <font color="#FF0000">)</font>   <font color="#006600">//enter port to listen in here</font>
    <font color="#FF0000">{</font>    
        <font color="#0088FF">char</font> szWASError<font color="#FF0000">[</font>WSA_ERROR_LEN<font color="#FF0000">]</font><font color="#FF0000">;</font>
        sockListener.WSAGetLastErrorMessage<font color="#FF0000">(</font> szWASError <font color="#FF0000">)</font><font color="#FF0000">;</font>
        printf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"*** Create Error: %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szWASError <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#FF0000">-</font><font color="#6600FF">1</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>

    <font color="#0088FF">if</font><font color="#FF0000">(</font> <font color="#FF0000">!</font>sockListener.Listen<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font>
    <font color="#FF0000">{</font>    
        <font color="#0088FF">char</font> szWASError<font color="#FF0000">[</font>WSA_ERROR_LEN<font color="#FF0000">]</font><font color="#FF0000">;</font>
        sockListener.WSAGetLastErrorMessage<font color="#FF0000">(</font> szWASError <font color="#FF0000">)</font><font color="#FF0000">;</font>
        printf<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"*** Listen Error: %s\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> szWASError <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">return</font> <font color="#FF0000">-</font><font color="#6600FF">1</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
</pre>

<p>That should be it. Now just test our application be running telnet. 
 From the command line type <code>telnet 127.0.0.1 392</code>. 
 It should start and echo the characters you type in plus 1. Start 
 another telnet session and the old one should terminate..</p>

<h1>Things to watch out for.<a name="_ThingsToWatchOutFor"></a></h1>

<p>Sockets are simple to use but do require attention in the following 
  areas;</p>

<h2>Reuse our code</h2>
<p>In the sample code I have duplicated the Client and Listener code 
 all over the place. If our are writing both the client and server 
 share as much code a possible.</p>
<h2>Data is not packets</h2>
<p>Developers often fall into the trap off assuming data sent with 
 a single <code>Send()</code> will be result in a single <code>OnRecieve()</code>. 
 This is NOT guaranteed to occur, and must assume packets will 
 be broken up or merged together.</p>

<h2>Connection loss is not always detectable</h2>

<p>The <code>OnClose()</code> event can be used to detect the remote machine shutting 
 down only if network connection between the machines is available 
 and the process terminates correctly. For this reason it is often 
 advisable to maintain a ping or heartbeat message between the 
 clients to ensure both machines are functioning correctly.</p>

<h2>Don't try to reuse sockets</h2>
<p>If connection is closed or lost for any reason, do not try to reopen 
 the connection with the same socket object. It is best to create 
 the objects on the heap with <code>new</code> and <code>delete</code> 
 them once they are done with. If you need to reconnect. delete 
 the object and use new to create a new one before reconnecting.</p>

<h2>Local machine</h2>

<p>It is handy to test and often connect to a server that is running 
  on the same machine as the client this is know as the <code>localhost 
  </code>or IP address <code>127.0.0.1</code>. </p>


 <h2>Resolving address names takes time</h2>

<p>Most operations are non-blocking, however when a connection is attempted 
  the address must be resolved from a name to a 4 digit IP. If a Domain 
  Name Server is not available this process can block for 30 seconds 
  or more. To avoid this always use 4 digit IP addresses rather than 
  domain names.</p>
<!-- #include virtual="/Inc/NoteFooter.inc" --> 




