


<!-- #include virtual="/Inc/NoteHeader.inc" --> 

      <a href="ToolTrayIcon.zip">Download Tool Tray class files - 3 Kb</a>
      <br>
      <h4>Description.</h4>
            
      <p>Placing an icon in the tool tray is quite a simple task and can 
      make it easier for the user to access your application without wasting screen space.
      </p>      
      
		<p>This class is just a light wrapper around the Windows 95 system
		tray icon notification facility. The constructor requires a CWnd
		object pointer in order to deliver the user-defined notification
		message, which must also be provided. It is up to the caller to 
		verify that a valid	notification index is provided.
		</p>
      
      
      <h4>How to setup.</h4>
      
      Add the following definition to <code>StdAfx.h</code> and add the two files in
      the zip file to the project.

<pre>
<font color="#0088FF">#define</font> WM_USER_TOOLTRAY   <font color="#FF0000">(</font>WM_USER<font color="#FF0000">+</font><font color="#6600FF">1</font><font color="#FF0000">)</font>   <font color="#006600">//Tool tray message</font>
</pre>      

		In the header of the window to recieve messages from the tool tray add the following
		

<pre>
<font color="#0088FF">#include</font> <font color="#FF00FF">"TrayNot.h"</font>                     <font color="#006600">//CToolTray class def.</font>
</pre>		

		Define in the private section of the class.
		
<pre>
<font color="#006600">//Attributes</font>
<font color="#0088FF">private</font><font color="#FF0000">:</font>
   CTrayNot <font color="#FF0000">*</font>m_pTrayNot<font color="#FF0000">;</font>            <font color="#006600">//Access to the tool tray icon</font>
</pre>		
	

		At the end of the message map add out handler.
		
<pre>
    <font color="#006600">//}}AFX_MSG</font>
    afx_msg LONG OnMyTrayNotify<font color="#FF0000">(</font> WPARAM wParam<font color="#FF0000">,</font> LPARAM lParam <font color="#FF0000">)</font><font color="#FF0000">;</font>
    DECLARE_MESSAGE_MAP<font color="#FF0000">(</font><font color="#FF0000">)</font>
</pre>

		Back in the Implementation file for the window, in the Constructor of the window object
		
<pre>
   <font color="#FF0000">,</font> m_pTrayNot<font color="#FF0000">(</font> NULL <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
  ...
</pre>

		At the end of the message map add our message handler

<pre>
    <font color="#006600">//}}AFX_MSG_MAP</font>
    ON_MESSAGE<font color="#FF0000">(</font>WM_USER_TOOLTRAY<font color="#FF0000">,</font> OnMyTrayNotify<font color="#FF0000">)</font>
END_MESSAGE_MAP<font color="#FF0000">(</font><font color="#FF0000">)</font>
</pre>
		
	In the <code>Create</code> or <code>InitDialog</code> functions
	create the object as follows;
	
<pre>
    <font color="#006600">//Setup the tool tray</font>
    m_pTrayNot <font color="#FF0000">=</font> <font color="#0088FF">new</font> CTrayNot<font color="#FF0000">(</font> <font color="#0088FF">this</font><font color="#FF0000">,</font> WM_USER_TOOLTRAY<font color="#FF0000">,</font> 
                               _T<font color="#FF0000">(</font><font color="#FF00FF">"My words here"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
</pre>

	Finally add the hendler for the popup menu that is to be displayed. Note the message ID's
	will need to be created along with the menu suitable for your application.

<pre>
<font color="#006600">/////////////////////////////////////////////////////////////////////</font>
<font color="#006600">//  Message to Handle the notification message from the Tray</font>
<font color="#006600">//  Either show the dialog OR a menu</font>
LONG CDlgAWWStuffer<font color="#FF0000">:</font><font color="#FF0000">:</font>OnMyTrayNotify<font color="#FF0000">(</font> WPARAM wParam<font color="#FF0000">,</font> LPARAM lParam <font color="#FF0000">)</font>
<font color="#FF0000">{</font>
    TRACE<font color="#FF0000">(</font> _T<font color="#FF0000">(</font><font color="#FF00FF">"CDlgAWWStuffer::OnMyTrayNotify( %d, %ld )\n"</font><font color="#FF0000">)</font><font color="#FF0000">,</font> 
        wParam<font color="#FF0000">,</font> lParam <font color="#FF0000">)</font><font color="#FF0000">;</font>
    <font color="#0088FF">switch</font> <font color="#FF0000">(</font> lParam <font color="#FF0000">)</font>nd the 
     <font color="#FF0000">{</font>
        <font color="#006600">//Do nothing</font>
        <font color="#0088FF">case</font> WM_LBUTTONDBLCLK<font color="#FF0000">:</font>
            MessageBeep<font color="#FF0000">(</font> <font color="#FF0000">-</font><font color="#6600FF">1</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
        <font color="#0088FF">case</font> WM_LBUTTONDOWN<font color="#FF0000">:</font>
            MessageBeep<font color="#FF0000">(</font> <font color="#FF0000">-</font><font color="#6600FF">1</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            <font color="#0088FF">break</font><font color="#FF0000">;</font>
        <font color="#006600">//Activate the pop up menu</font>
        <font color="#0088FF">case</font> WM_RBUTTONDOWN<font color="#FF0000">:</font>
            <font color="#006600">//Create the popup menu with mini icons</font>
            CMenu menu<font color="#FF0000">;</font>
            VERIFY<font color="#FF0000">(</font> menu.CreatePopupMenu<font color="#FF0000">(</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            menu.AppendMenu<font color="#FF0000">(</font>MF_STRING<font color="#FF0000">,</font> ID_FILE_SEARCHFORITEM<font color="#FF0000">,</font>    
                _T<font color="#FF0000">(</font><font color="#FF00FF">"Show &Find"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            menu.AppendMenu<font color="#FF0000">(</font>MF_STRING<font color="#FF0000">,</font> ID_FILE_SELECTBYCATEGORY<font color="#FF0000">,</font> 
                _T<font color="#FF0000">(</font><font color="#FF00FF">"Show &Category"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
            menu.AppendMenu<font color="#FF0000">(</font>MF_STRING<font color="#FF0000">,</font> ID_APP_REALLY_EXIT<font color="#FF0000">,</font>       
                _T<font color="#FF0000">(</font><font color="#FF00FF">"E&xit"</font><font color="#FF0000">)</font> <font color="#FF0000">)</font><font color="#FF0000">;</font>
                
            <font color="#006600">//Position and Display</font>
            POINT pt <font color="#FF0000">;</font>
            GetCursorPos <font color="#FF0000">(</font> <font color="#FF0000">&</font>pt <font color="#FF0000">)</font> <font color="#FF0000">;</font>

            SetForegroundWindow<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>

            <font color="#0088FF">int</font> nSelection <font color="#FF0000">=</font>  menu.TrackPopupMenu <font color="#FF0000">(</font>  
                TPM_RETURNCMD <font color="#FF0000">|</font> TPM_LEFTALIGN <font color="#FF0000">|</font> TPM_RIGHTBUTTON<font color="#FF0000">,</font>
                pt.x<font color="#FF0000">,</font> pt.y<font color="#FF0000">,</font> AfxGetMainWnd<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">,</font> NULL <font color="#FF0000">)</font><font color="#FF0000">;</font>

            menu.DestroyMenu<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>

            <font color="#0088FF">switch</font><font color="#FF0000">(</font> nSelection <font color="#FF0000">)</font>
            <font color="#FF0000">{</font>
                <font color="#0088FF">case</font> ID_FILE_SEARCHFORITEM<font color="#FF0000">:</font>
                <font color="#0088FF">case</font> ID_FILE_SELECTBYCATEGORY<font color="#FF0000">:</font>
                    <font color="#006600">//OnHotKey();</font>
                    <font color="#006600">//OnSelectView( nSelection );</font>
                <font color="#0088FF">break</font><font color="#FF0000">;</font>
                <font color="#0088FF">case</font> ID_APP_REALLY_EXIT<font color="#FF0000">:</font>
                    OnAppReallyExit<font color="#FF0000">(</font><font color="#FF0000">)</font><font color="#FF0000">;</font>
                    <font color="#0088FF">break</font><font color="#FF0000">;</font>
            <font color="#FF0000">}</font>
        <font color="#FF0000">}</font>
        <font color="#0088FF">break</font><font color="#FF0000">;</font>
    <font color="#FF0000">}</font>
    <font color="#0088FF">return</font> <font color="#6600FF">0</font><font color="#FF0000">;</font>
<font color="#FF0000">}</font>
</pre>



<!-- #include virtual="/Inc/NoteFooter.inc" --> 




