// TrySdiTreeView.h : interface of the CTrySdiTreeView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRYSDITREEVIEW_H__E2C1ADD1_892A_11D4_ABBE_00508B4D9A5B__INCLUDED_)
#define AFX_TRYSDITREEVIEW_H__E2C1ADD1_892A_11D4_ABBE_00508B4D9A5B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CTrySdiTreeView : public CTreeView
{
protected: // create from serialization only
	CTrySdiTreeView();
	DECLARE_DYNCREATE(CTrySdiTreeView)

// Attributes
public:
	CTrySdiTreeDoc* GetDocument();

// Operations
public:

	
	//Quick and Nasty one liners.
	CString GetPath() const					{ return m_sPath; }
	void	SetPath( CString sPath )		{ m_sPath = sPath; }

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTrySdiTreeView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTrySdiTreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTrySdiTreeView)
	afx_msg void OnDestroy();
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()


//Operators
private:
	CString GetItemPath( HTREEITEM hItem );
	bool	PopulateTree( CString sPath, HTREEITEM hParent );
	HTREEITEM InsertItem( HTREEITEM hParent, NETRESOURCE *const pNetResource, CString sText, int iImage, int iImageSelected = -1 );
	bool	EnumNetwork( HTREEITEM hParent );

//Attributes
private:
	CImageList	m_ImageListTree;					//Item in the Tree image list				
	HTREEITEM	m_hNetworkRoot;						//Network neighbourhood root
	CString		m_sPath;							//Highlighted path


};

#ifndef _DEBUG  // debug version in TrySdiTreeView.cpp
inline CTrySdiTreeDoc* CTrySdiTreeView::GetDocument()
   { return (CTrySdiTreeDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRYSDITREEVIEW_H__E2C1ADD1_892A_11D4_ABBE_00508B4D9A5B__INCLUDED_)
