// CallbackServer.cpp : Implementation of CCallbackServer
#include "stdafx.h"
#include "DemoCallback.h"
#include "CallbackServer.h"


// ***************************************************************************
//DESCRIPTION:
//		Pass the interface pointer the client has exposed to be
//		called back on.  Call this once at startup.
//CREATED:
//		11-12-2000, 1:30:45 AM by john@mctainsh.com
// ***************************************************************************
STDMETHODIMP CCallbackServer::JrmAdvise(ICallbackEntry *pEntry)
{
	if( m_pCallback )
		return MAKE_HRESULT( 3, FACILITY_RPC, ERROR_REQ_NOT_ACCEP );
	m_pCallback = pEntry;
	m_pCallback->AddRef();
	return S_OK;
}


// ***************************************************************************
//DESCRIPTION:
//		Calls back into the client using a client provided interface
//CREATED:
//		11-12-2000, 1:30:42 AM by john@mctainsh.com
// ***************************************************************************
STDMETHODIMP CCallbackServer::SimulateCallback()
{
	if( m_pCallback == NULL )
		return MAKE_HRESULT( 3, FACILITY_RPC, ERROR_CONNECTION_UNAVAIL );
	m_pCallback->JrmEvent1();
	return S_OK;
}
