// CallbackServer.h : Declaration of the CCallbackServer

#ifndef __CALLBACKSERVER_H_
#define __CALLBACKSERVER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CCallbackServer
class ATL_NO_VTABLE CCallbackServer : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CCallbackServer, &CLSID_CallbackServer>,
	public ICallbackServer
{
public:
	//Setup and shut down code
	CCallbackServer() : m_pCallback( NULL )
	{
	}

	void FinalRelease( )
	{
		if( m_pCallback )
			m_pCallback->Release();
		m_pCallback = NULL;
	}


DECLARE_REGISTRY_RESOURCEID(IDR_CALLBACKSERVER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CCallbackServer)
	COM_INTERFACE_ENTRY(ICallbackServer)
END_COM_MAP()

// ICallbackServer
public:
	STDMETHOD(SimulateCallback)();
	STDMETHOD(JrmAdvise)(/*[in]*/  ICallbackEntry* pEntry);

//Attributes
private:
	ICallbackEntry* m_pCallback;
};

#endif //__CALLBACKSERVER_H_
