// DemoMFCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DemoMFC.h"
#include "DemoMFCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


// NOTE: CheckHRESULT is a helper function that takes an HRESULT
//       and a function name as parameters and displays an error
//       message if the HRESULT's severity bit indicates an error
//       has happened. This function never returns if an error
//       has occurred.
void CheckHRESULT(HRESULT hr, const char *pszCause)
{
    if (FAILED(hr))
    {
		const int ERROR_LEN = 1024;
        char sz[ERROR_LEN+1];
        char szCaption[ERROR_LEN+1];
        strcpy( szCaption, pszCause );
        strcat( szCaption, " failed!" );
        if( !FormatMessageA( FORMAT_MESSAGE_FROM_SYSTEM, 0, hr, 0, sz, ERROR_LEN, 0 ) )
            strcpy( sz, "Unknown error" );
        MessageBox( 0, sz, szCaption, MB_SETFOREGROUND );
        DebugBreak();
    }
}




/////////////////////////////////////////////////////////////////////////////
// CDemoMFCDlg dialog
CDemoMFCDlg::CDemoMFCDlg(CWnd* pParent /*=NULL*/) :
	CDialog(CDemoMFCDlg::IDD, pParent),
	m_pCallBack( NULL ),
	m_pServer( NULL )
{
	//{{AFX_DATA_INIT(CDemoMFCDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


// ***************************************************************************
//DESCRIPTION:
//		Clean up before going home.
//CREATED:
//		20-12-2000, 9:30:46 PM by john@mctainsh.com
// ***************************************************************************
BOOL CDemoMFCDlg::DestroyWindow() 
{
	TRACE( _T("CDemoMFCDlg::DestroyWindow() \n") );
	m_pCallBack->Release();
	m_pServer->Release();
	return CDialog::DestroyWindow();
}

void CDemoMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoMFCDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoMFCDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoMFCDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoMFCDlg message handlers
BOOL CDemoMFCDlg::OnInitDialog()
{
	TRACE( _T("CDemoMFCDlg::OnInitDialog()\n") );
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

	//
	//Setup for Com communications
	//
	HRESULT hr = CoInitialize( NULL );
	CheckHRESULT( hr, "CoInitialize" );

	hr = CoCreateInstance( 
			CLSID_CallbackServer, 
			NULL, CLSCTX_ALL, 
			__uuidof( m_pServer ), 
			(void**)&m_pServer );
	CheckHRESULT( hr, "CoCreateInstance of CallbackServer" );

	//
	//Expose the callback interface
	//
	m_pCallBack = new CCallbackEntry;
	m_pCallBack->AddRef();
	hr = m_pServer->JrmAdvise( m_pCallBack );
	CheckHRESULT( hr, "JrmAdvise" );


	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CDemoMFCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoMFCDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


// ***************************************************************************
//DESCRIPTION:
//		When OK is pressed call a method on the control.
//CREATED:
//		20-12-2000, 8:48:56 PM by john@mctainsh.com
// ***************************************************************************
void CDemoMFCDlg::OnOK() 
{
	TRACE( _T("CDemoMFCDlg::OnOK() \n") );
	HRESULT hr = m_pServer->SimulateCallback();
	CheckHRESULT( hr, "SimulateCallback" );
}

