// TestNoMFC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "SockClient.h"


int main(int /*argc*/, char* /*argv[]*/)
{
	printf("Starting Client!\n");

	//Initialise for Socket communications
	if( CSockClient::SocketInit() != 0 )
	{
		TCHAR szErrorMsg[WSA_ERROR_LEN];
		CSockClient::WSAGetLastErrorMessage( szErrorMsg );
		_tprintf( _T("Initialise failed Error: %s"), szErrorMsg );
		//TODO: Error processing.
		return -1;
	}

	//Connect to the server
	CSockClient sock;
	if( sock.Create() == false ||
		sock.Connect( _T("127.0.0.1"), 392 ) == false )
	{
		TCHAR szErrorMsg[WSA_ERROR_LEN];
		CSockClient::WSAGetLastErrorMessage( szErrorMsg );
		_tprintf( _T("Socket Create/Connect failed Error: %s"), szErrorMsg );
		//TODO: Error processing.
		return -1;
	}

	//Wait to be ready
	int nTrys = 100;
	while( !sock.IsConnected() )
	{
		if( nTrys-- < 0 )
		{
			_tprintf( _T("** FAULT : Unable to send, Not ready\n") );
			return -1;
		}
		Sleep( 10 );
	}

	//Send
	sock.Send( "Hello", 5 );

	//Wait for reply
	Sleep( 5000 );



	return 0;
}

